local modName = ...
local Addon = LibStub('AceAddon-3.0'):GetAddon(GetAddOnDependencies(modName))
local bar = Addon:CreateClass('Frame', Addon.Frame)
_G[modName] = bar
bar.master = Addon
bar.lib = LibStub('LibSharedMedia-3.0', true)

bar.frames = {}

function bar:New(name)
	local name = string.lower(name)
	local f = self.proto.New(self, name)
	f:Reload()
	bar.frames[name] = bar.frames[name] or f
	return f
end

local Basics = {
	overlay = {
		enable = true,
	},
	debuffs = {
		columns = 6,
		scale = 76,
		color = {
			a = 1,
			b = 0,
			g = 0,
			r = 0,
		},
		rows = 3,
		isLeftToRight = true,
		x = 0,
		y = -73,
		isTopToBottom = true,
		sort = "Duration",
		spacing = 0,
		anchor = "Top",
		enable = false,
		showBG = false,
		alpha = 100,
	},
	focus = {
		y = -12,
		usePortrait = true,
		mouseOverTooltip = true,
		x = -42,
		enable = true,
		scale = 95,
		alpha = 100,
		anchor = "TopRight",
	},
	level = {
		scale = 100,
		justifyV = 1,
		width = 25,
		y = -16,
		x = 63,
		justifyH = 2,
		height = 12,
		enable = true,
		anchor = "Center",
	},
	threat = {
		scale = 100,
		justifyV = 1,
		width = 35,
		y = 12,
		x = 0,
		justifyH = 3,
		height = 12,
		anchor = "top",
		enable = true,
	},
	power = {
		maxTextWidth = 1000,
		prevOrient = "HORIZONTAL",
		scale = 100,
		justifyV = "CENTER",
		textureName = "Raid",
		xTextOffset = 0,
		textY = 0,
		justifyH = "CENTER",
		drop = true,
		anchor = "TopRight",
		format = "percent",
		texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
		textVert = 2,
		orient = "HORIZONTAL",
		textHori = 2,
		textX = 0,
		mouseover = "value",
		yTextOffset = 0,
		CurveOffset = 0,
		alpha = 100,
		width = 115,
		y = -52,
		x = -111,
		mouseOverTooltip = true,
		arc = 0,
		height = 12,
		anchorText = "Center",
		percent = true,
		enable = true,
	},
	health = {
		maxTextWidth = 300,
		prevOrient = "HORIZONTAL",
		scale = 100,
		justifyV = "CENTER",
		textureName = "Raid",
		justifyH = "CENTER",
		drop = true,
		anchor = "TopRight",
		format = "value",
		texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
		textVert = 2,
		orient = "HORIZONTAL",
		textY = 0,
		textX = 0,
		mouseover = "value",
		textHori = 2,
		CurveOffset = 0,
		alpha = 100,
		width = 115,
		y = -41,
		x = -110,
		mouseOverTooltip = true,
		arc = 0,
		height = 12,
		anchorText = "Center",
		percent = true,
		enable = true,
	},
	icons = {
		alpha = 100,
		scale = 130,
		columns = 8,
		frameLayer = 3,
		enable = true,
		height = 45,
		IsLeftToRight = false,
		width = 45,
		y = 2,
		x = -45,
		style = "ROUND",
		spacing = 0,
		anchor = "Right",
		angle = 313,
		IsTopToBottom = true,
		compress = 0,
	},
	name = {
		enable = true,
		justifyV = 1,
		width = 100,
		y = 19,
		x = -50,
		justifyH = 2,
		anchor = "Center",
		scale = 100,
		height = 12,
	},
	model = {
		zoom = 0,
		frameLevel = 1,
		frameLayer = 1,
		scale = 1,
		justifyV = "CENTER",
		width = 133,
		y = -45,
		x = -110,
		justifyH = "CENTER",
		clickThru = true,
		anchor = "BottomLeft",
		enable = false,
		height = 197,
		rotation = 0,
	},
	buffs = {
		columns = 6,
		color = {
			a = 1,
			b = 0,
			g = 0,
			r = 0,
		},
		scale = 64,
		rows = 1,
		isLeftToRight = true,
		isTopToBottom = false,
		y = 6,
		x = 12,
		sort = "Duration",
		spacing = 0,
		anchor = "BottomLeft",
		enable = false,
		showBG = false,
		alpha = 100,
	},
	cast = {
		maxTextWidth = 98,
		scale = 100,
		sparkY = 0,
		Sparkarc = 0,
		anchor = "Left",
		textureName = "Blizzard",
		texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
		xTextOffset = 0,
		textY = 0,
		frameLevel = 2,
		textX = 0,
		frameLayer = 4,
		yTextOffset = 0,
		CurveOffset = 0,
		alpha = 100,
		width = 117,
		y = 17,
		x = 7,
		mouseOverTooltip = true,
		arc = 0,
		height = 16,
		anchorText = "Center",
		showBG = false,
		enable = true,
	},
	background = {
		edgeSize = 13,
		color = {
			a = 0.5,
			b = 0,
			g = 0,
			r = 0,
		},
		texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
		scale = 100,
		bgPad = 0,
		width = 51,
		textureName = "Blizzard Tooltip",
		y = -26,
		x = -111,
		height = 41,
		edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
		anchor = "TopRight",
		edgecolor = {
			a = 100,
			b = 100,
			g = 100,
			r = 100,
		},
		inset = 0,
		enable = true,
	},

}




local defaults = {
	focus = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'playerBR',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
	},
	targettarget = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'targetRB',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 420,
		padH = 3,
		height = 100,
	},
	target = {
		scale = 1,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		point = 'TopLeft',
		padW = 3,
		width = 232,
		y = 0,
		x = 235,
		padH = 3,
		height = 100,
		debuffs = {
			columns = 6,
			scale = 76,
			color = {
				a = 1,
				b = 0,
				g = 0,
				r = 0,
			},
			rows = 3,
			isLeftToRight = true,
			x = 0,
			y = -73,
			isTopToBottom = true,
			sort = "Duration",
			spacing = 0,
			anchor = "Top",
			enable = true,
			showBG = false,
			alpha = 100,
		},
		buffs = {
			columns = 6,
			color = {
				a = 1,
				b = 0,
				g = 0,
				r = 0,
			},
			scale = 64,
			rows = 1,
			isLeftToRight = true,
			isTopToBottom = false,
			y = 6,
			x = 12,
			sort = "Duration",
			spacing = 0,
			anchor = "BottomLeft",
			enable = true,
			showBG = false,
			alpha = 100,
		},

	},
	player = {
		scale = 1,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		point = 'TopLeft',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
		overlay = {
			enable = true,
		},
		debuffs = {
			columns = 6,
			isLeftToRight = true,
			color = {
				a = 1,
				r = 0,
				g = 0,
				b = 0,
			},
			rows = 3,
			alpha = 100,
			isTopToBottom = true,
			y = -73,
			x = 0,
			sort = "Duration",
			spacing = 0,
			anchor = "Top",
			enable = false,
			showBG = false,
			scale = 76,
		},
		cast = {
			textY = 0,
			enable = true,
			textheight = 12,
			Sparkarc = 0,
			sparkY = 0,
			anchor = "Left",
			texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
			showBG = false,
			CurveOffset = 0,
			yTextOffset = 0,
			xTextOffset = 0,
			frameLevel = 2,
			frameLayer = 4,
			textX = 0,
			maxTextWidth = 98,
			alpha = 100,
			width = 117,
			y = 17,
			x = 225,
			mouseOverTooltip = true,
			arc = 0,
			height = 16,
			anchorText = "Center",
			scale = 100,
			textureName = "Blizzard",
		},
		focus = {
			y = -12,
			x = 42,
			mouseOverTooltip = true,
			enable = true,
			anchor = "TopLeft",
			scale = 95,
			alpha = 100,
			usePortrait = true,
		},
		level = {
			scale = 100,
			justifyV = 1,
			width = 25,
			y = -16,
			x = -63,
			justifyH = 2,
			anchor = "Center",
			enable = true,
			height = 12,
		},
		threat = {
			scale = 100,
			justifyV = 1,
			width = 35,
			y = 12,
			x = 0,
			justifyH = 3,
			height = 12,
			enable = true,
			anchor = "top",
		},
		background = {
			edgeSize = 13,
			inset = 0,
			color = {
				a = 0.5,
				r = 0,
				g = 0,
				b = 0,
			},
			enable = true,
			bgPad = 0,
			edgecolor = {
				a = 100,
				r = 100,
				g = 100,
				b = 100,
			},
			textureName = "Blizzard Tooltip",
			y = -26,
			x = 111,
			width = 51,
			edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			anchor = "TopLeft",
			height = 41,
			texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
			scale = 100,
		},
		power = {
			maxTextWidth = 300,
			prevOrient = "HORIZONTAL",
			scale = 100,
			justifyV = "CENTER",
			textureName = "Raid",
			enable = true,
			yTextOffset = 0,
			justifyH = "CENTER",
			drop = true,
			anchor = "TopLeft",
			format = "percent",
			texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
			textY = 0,
			orient = "HORIZONTAL",
			xTextOffset = 0,
			textVert = 2,
			textHori = 2,
			alpha = 100,
			textX = 0,
			mouseover = "value",
			width = 116,
			y = -52,
			CurveOffset = 0,
			mouseOverTooltip = true,
			arc = 0,
			height = 12,
			anchorText = "Center",
			percent = true,
			x = 109,
		},
		icons = {
			frameLayer = 3,
			enable = true,
			columns = 8,
			compress = 0,
			scale = 130,
			alpha = 100,
			IsLeftToRight = false,
			width = 45,
			y = 2,
			IsTopToBottom = true,
			style = "ROUND",
			spacing = 0,
			height = 45,
			angle = 227,
			x = 45,
			anchor = "Left",
		},
		health = {
			textY = 0,
			prevOrient = "HORIZONTAL",
			scale = 100,
			justifyV = "CENTER",
			textureName = "Raid",
			classColor = false,
			justifyH = "CENTER",
			drop = true,
			anchor = "TopLeft",
			format = "value",
			texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
			enable = true,
			orient = "HORIZONTAL",
			maxTextWidth = 300,
			textVert = 2,
			textX = 0,
			textHori = 2,
			alpha = 100,
			mouseover = "value",
			width = 115,
			y = -41,
			x = 110,
			mouseOverTooltip = true,
			arc = 0,
			height = 12,
			anchorText = "Center",
			percent = true,
			CurveOffset = 0,
		},
		model = {
			zoom = 0,
			frameLevel = 1,
			frameLayer = 1,
			scale = 1,
			justifyV = "CENTER",
			width = 133,
			y = -45,
			x = -110,
			justifyH = "CENTER",
			rotation = 0,
			anchor = "BottomLeft",
			height = 197,
			enable = false,
			clickThru = true,
		},
		buffs = {
			columns = 6,
			isLeftToRight = true,
			scale = 64,
			rows = 1,
			alpha = 100,
			x = 94,
			y = 7,
			isTopToBottom = false,
			sort = "Duration",
			spacing = 0,
			anchor = "BottomLeft",
			enable = false,
			showBG = false,
			color = {
				a = 1,
				r = 0,
				g = 0,
				b = 0,
			},
		},
		name = {
			enable = true,
			justifyV = 1,
			width = 100,
			y = 19,
			x = 50,
			justifyH = 2,
			height = 12,
			scale = 100,
			anchor = "Center",
		},
	},
	focustarget = {
		scale = .7,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'focusRB',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
	},
	playerpet = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'focusBL',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
	},
}

for i, b in pairs(defaults) do
	if i ~= "player" then
		for add, info in pairs(Basics) do
			if not b[add] then
				b[add] = CopyTable(info)
			end
		end
	end
end

bar.DEFAULTS = defaults

local function check(source, target)
	--you may now add new defaults at will. ~Goranaws
	if not target then 
		target = {}
	end
	if not source then
		--return
	end
	for key, value in pairs(source) do
		if type(value) == 'table' then
			target[key] =check(value, target[key])
		else
			if (type(value) == 'boolean') then
				if target[key] == nil then
	target[key] = value
				end
 			else
 				target[key] = target[key] or value
 			end
		end
	end
	return target
end
bar.check = check

function bar:GetDefaults()
	local def
	if self and self.id and defaults[self.id] then 
		def = check(defaults[self.id])
	else
		def = CopyTable({
		scale = 1,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		point = 'Center',
		padW = 0,
		width = 232,
		y = 0,
		x = 0,
		padH = 0,
		height = 100,
	})
	end
	return def
end

function bar:Reload()
	self.sets = self.sets or CopyTable(self:GetDefaults()) --check(self:GetDefaults(), self.sets)
	if self.Load then
		self:Load()
	end
	self:SetParent(self.parent or self:GetParent())
	self:Layout()
end

function bar:Disable()
	self:Free()
end

function bar:Layout()
	if self.UpdateComponents then
		self:UpdateComponents()
	else
		local pad = self:GetPadding()
		local w, h = self.sets.width + pad, self.sets.height + pad
		self:SetSize(w, h)
	end
end
