local bar = _G[...]
local modName = ...
local L
local NAME = 1
local function Menu(menu, name, key, table, sub)
	local f = CreateFrame('Frame', NAME..name, menu)
	NAME = NAME + 1
	f:SetSize(24, 24)
	f.button = CreateFrame('Button', f:GetName()..'Button', f)
	f.dumb = CreateFrame('Frame', nil, f)
	f.dumb:SetSize(24, 24)
	f.dumb:SetPoint('TopLeft')
	f.button:SetSize(24, 24)
	f.button:SetNormalTexture('Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up')
	f.button:SetPushedTexture('Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Down')
	f.button:SetDisabledTexture('Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Disabled')
	f.button:SetHighlightTexture('Interface\\Buttons\\UI-Common-MouseHilight')
	f.text = f:CreateFontString(f:GetName() .. 'Text', 'OVERLAY', 'GameFontHighlightSmall')
	f.text:SetPoint('BottomLeft', f.button, 'BottomRight', 6, 2)
	f.text:SetJustifyH('LEFT')
	local title = f:CreateFontString(nil, 'OVERLAY', 'GameFontNormalSmall')
	title:SetPoint('TopLeft', f.button, 'TopRight', 4, -2)
	title:SetText(name)
	f.title = title

	f:SetScript('OnHide', function() CloseDropDownMenus() end)
	f.button:SetScript('OnClick', function(self)
		UIDropDownMenu_SetAnchor(f, -4, 6, 'TopLeft', f.button, 'BottomLeft')
		ToggleDropDownMenu(1, 1, f)
		PlaySound('igMainMenuOptionCheckBoxOn')
	end)

	local dropDownList = _G['DropDownList'..1]
	dropDownList.dropdown = f
	dropDownList.shouldRefresh = true
	
	
	if sub then
		f.button:SetPoint('Top', 10, 0)
	else
		f.button:SetPoint('Top')
	end
	
	local prev = menu.lastWidget
	if prev then
		f:SetPoint('TOPLEFT', prev, 'BOTTOMLEFT', 0, -0)
	else
		f:SetPoint('TOPLEFT', 2, -5)
	end
	f.point = {f:GetPoint()}
	menu.lastWidget = f.dumb
	f.button:SetHitRectInsets(0, 0 , 0, 0)
	menu.height = menu.height + 24
	return f
end

local blackList = {
	point = 1,
	x = 1,
	y = 1,
	anchor = 1,
}

local function Copy(source, destination, looped)
	if not destination then
		destination = {}
	end
	for i, b in pairs(CopyTable(source)) do
		if (type(b) == 'table') then
			destination[i] = Copy(b, destination[i], true)
		else
			if (not looped) and (blackList[i]) then
				
			else
				destination[i] = b
			end
		end
	end
	return destination
end


do --Copy functions
    local Base = {
        defaults = {
            focus = {
                scale = .75,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                anchor  = 'playerBR',
                point = 'Center',
                padW = 3,
                width = 232,
                y = 0,
                x = 0,
                padH = 3,
                height = 100,
            },
            targettarget = {
                scale = .75,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                anchor  = 'targetRB',
                point = 'Center',
                padW = 3,
                width = 232,
                y = 0,
                x = 420,
                padH = 3,
                height = 100,
            },
            target = {
                scale = 1,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                point = 'TopLeft',
                padW = 3,
                width = 232,
                y = 0,
                x = 235,
                padH = 3,
                height = 100,
                debuffs = {
                    columns = 6,
                    scale = 76,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    rows = 3,
                    isLeftToRight = true,
                    x = 0,
                    y = -73,
                    isTopToBottom = true,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "Top",
                    enable = true,
                    showBG = false,
                    alpha = 100,
                },
                buffs = {
                    columns = 6,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    scale = 64,
                    rows = 1,
                    isLeftToRight = true,
                    isTopToBottom = false,
                    y = 6,
                    x = 12,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = true,
                    showBG = false,
                    alpha = 100,
                },

            },
            player = {
                scale = 1,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                point = 'TopLeft',
                padW = 3,
                width = 232,
                y = 0,
                x = 0,
                padH = 3,
                height = 100,
                overlay = {
                    enable = true,
                },
                debuffs = {
                    columns = 6,
                    isLeftToRight = true,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    rows = 3,
                    alpha = 100,
                    isTopToBottom = true,
                    y = -73,
                    x = 0,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "Top",
                    enable = false,
                    showBG = false,
                    scale = 76,
                },
                cast = {
                    textY = 0,
                    enable = true,
                    textheight = 12,
                    Sparkarc = 0,
                    sparkY = 0,
                    anchor = "Left",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    showBG = false,
                    CurveOffset = 0,
                    yTextOffset = 0,
                    xTextOffset = 0,
                    frameLevel = 2,
                    frameLayer = 4,
                    textX = 0,
                    maxTextWidth = 98,
                    alpha = 100,
                    width = 117,
                    y = 17,
                    x = 225,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 16,
                    anchorText = "Center",
                    scale = 100,
                    textureName = "Blizzard",
                },
                focus = {
                    y = -12,
                    x = 42,
                    mouseOverTooltip = true,
                    enable = true,
                    anchor = "TopLeft",
                    scale = 95,
                    alpha = 100,
                    usePortrait = true,
                },
                level = {
                    scale = 100,
                    justifyV = 1,
                    width = 25,
                    y = -16,
                    x = -63,
                    justifyH = 2,
                    anchor = "Center",
                    enable = true,
                    height = 12,
                },
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 3,
                    height = 12,
                    enable = true,
                    anchor = "top",
                },
                background = {
                    edgeSize = 13,
                    inset = 0,
                    color = {
                        a = 0.5,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    enable = true,
                    bgPad = 0,
                    edgecolor = {
                        a = 100,
                        r = 100,
                        g = 100,
                        b = 100,
                    },
                    textureName = "Blizzard Tooltip",
                    y = -26,
                    x = 111,
                    width = 51,
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    anchor = "TopLeft",
                    height = 41,
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    scale = 100,
                },
                power = {
                    maxTextWidth = 300,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    enable = true,
                    yTextOffset = 0,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textY = 0,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textVert = 2,
                    textHori = 2,
                    alpha = 100,
                    textX = 0,
                    mouseover = "value",
                    width = 116,
                    y = -52,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    x = 109,
                },
                icons = {
                    frameLayer = 3,
                    enable = true,
                    columns = 8,
                    compress = 0,
                    scale = 130,
                    alpha = 100,
                    IsLeftToRight = false,
                    width = 45,
                    y = 2,
                    IsTopToBottom = true,
                    style = "ROUND",
                    spacing = 0,
                    height = 45,
                    angle = 227,
                    x = 45,
                    anchor = "Left",
                },
                health = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    classColor = false,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    enable = true,
                    orient = "HORIZONTAL",
                    maxTextWidth = 300,
                    textVert = 2,
                    textX = 0,
                    textHori = 2,
                    alpha = 100,
                    mouseover = "value",
                    width = 115,
                    y = -41,
                    x = 110,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    CurveOffset = 0,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = -110,
                    justifyH = "CENTER",
                    rotation = 0,
                    anchor = "BottomLeft",
                    height = 197,
                    enable = false,
                    clickThru = true,
                },
                buffs = {
                    columns = 6,
                    isLeftToRight = true,
                    scale = 64,
                    rows = 1,
                    alpha = 100,
                    x = 94,
                    y = 7,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = false,
                    showBG = false,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                },
                name = {
                    enable = true,
                    justifyV = 1,
                    width = 100,
                    y = 19,
                    x = 50,
                    justifyH = 2,
                    height = 12,
                    scale = 100,
                    anchor = "Center",
                },
            },
            focustarget = {
                scale = .7,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                anchor  = 'focusRB',
                point = 'Center',
                padW = 3,
                width = 232,
                y = 0,
                x = 0,
                padH = 3,
                height = 100,
            },
            playerpet = {
                scale = .75,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                anchor  = 'focusBL',
                point = 'Center',
                padW = 3,
                width = 232,
                y = 0,
                x = 0,
                padH = 3,
                height = 100,
            },
	vehicle = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'focusBL',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
	},

			},
        Author =  {
		["boss1"] = {
			["overlay"] = {
				["y"] = 0,
				["x"] = 0,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["enable"] = false,
			},
			["debuffs"] = {
				["frameStrata"] = 2,
				["alpha"] = 100,
				["columns"] = 7,
				["frameLayer"] = 1,
				["scale"] = 77,
				["rows"] = 2,
				["isLeftToRight"] = true,
				["x"] = 354,
				["y"] = 47,
				["isTopToBottom"] = false,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["enable"] = false,
				["showBG"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
			},
			["resource"] = {
				["enable"] = true,
				["columns"] = 1,
				["compress"] = 0,
				["scale"] = 64,
				["anchor"] = "BottomLeft",
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["isTopToBottom"] = false,
				["style"] = "Bar",
				["spacing"] = 0,
				["height"] = 50,
				["angle"] = 0,
				["showBG"] = false,
				["x"] = 12,
			},
			["scale"] = 1,
			["Class"] = {
				["textY"] = 0,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "value",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["orient"] = "HORIZONTAL",
				["textVert"] = 2,
				["textX"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -41,
				["x"] = -106,
				["mouseover"] = "value",
				["textHori"] = 2,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["scale"] = 100,
			},
			["cast"] = {
				["prevOrient"] = "HORIZONTAL",
				["multi"] = true,
				["textheight"] = 12,
				["backdropOpacity"] = 50,
				["arcMid"] = 0,
				["anchor"] = "Right",
				["showBG"] = false,
				["orient"] = "HORIZONTAL",
				["textAnchor"] = "Center",
				["frameLayer"] = 4,
				["yTextOffset"] = 0,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 22,
				["rotate"] = 0,
				["textY"] = 0,
				["enable"] = true,
				["textureName"] = "Blizzard",
				["Sparkarc"] = 0,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["frameLevel"] = 2,
				["alpha"] = 100,
				["x"] = -1,
				["frameStrata"] = 2,
				["width"] = 122,
				["y"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["maxTextWidth"] = 98,
				["sparkY"] = 0,
				["textX"] = 0,
				["anchorText"] = "Center",
			},
			["altPower"] = {
				["maxTextWidth"] = 1000,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["textVert"] = 2,
				["backdropOpacity"] = 50,
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textHori"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["mouseover"] = "value",
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["scale"] = 86,
				["alpha"] = 100,
				["y"] = 0,
				["x"] = -2,
				["mouseOverTooltip"] = true,
				["anchor"] = "Left",
				["frameStrata"] = 2,
				["enable"] = true,
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 2,
				["width"] = 25,
				["y"] = 0,
				["x"] = 0,
				["justifyH"] = 2,
				["height"] = 26,
				["frameStrata"] = 2,
				["anchor"] = "Right",
				["enable"] = true,
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = 12,
				["x"] = 0,
				["justifyH"] = 3,
				["height"] = 12,
				["frameStrata"] = 2,
				["enable"] = true,
				["anchor"] = "top",
			},
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 0.5,
				["anchor"] = "BottomRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["enable"] = true,
				["maxTextWidth"] = 98,
				["alpha"] = 100,
				["width"] = 124,
				["textVert"] = 2,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["x"] = 0,
				["y"] = -1,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["background"] = {
				["color"] = {
					["a"] = 0.5,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["r"] = 100,
					["g"] = 100,
					["b"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "Right",
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 91,
				["y"] = 0,
				["x"] = 0,
				["height"] = 51,
				["inset"] = 0,
				["scale"] = 100,
				["enable"] = true,
			},
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["spin"] = 0,
				["scale"] = 78,
				["space"] = 0,
				["IsLeftToRight"] = false,
				["enable"] = true,
				["frameStrata"] = 2,
				["xFlex"] = 0,
				["frameLayer"] = 4,
				["spacing"] = 0,
				["anchor"] = "Left",
				["angle"] = 46,
				["rings"] = 1,
				["yArc"] = 0,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["compress"] = 0,
				["xArc"] = 0,
				["isLeftToRight"] = true,
				["alpha"] = 100,
				["width"] = 55,
				["y"] = 0,
				["x"] = 0,
				["style"] = "SQUARE",
				["reverse"] = true,
				["height"] = 55,
				["isTopToBottom"] = false,
				["yShift"] = 0,
				["IsTopToBottom"] = true,
			},
			["width"] = 173,
			["class"] = {
				["scale"] = 100,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -51,
				["x"] = 0,
				["drop"] = true,
				["height"] = 12,
				["enable"] = true,
				["anchor"] = "BottomRight",
			},
			["Health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textVert"] = 2,
				["leftOffset"] = 0,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 51,
				["enable"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["textHori"] = 2,
				["textY"] = 0,
				["textX"] = 0,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 1,
				["backdropOpacity"] = 0.5,
				["arcMid"] = 0,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["bottomOffset"] = 1,
				["frameLayer"] = 1,
				["mouseover"] = "current",
				["y"] = 0,
				["x"] = 0,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 98,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["height"] = 12,
				["textVert"] = 2,
				["orient"] = "HORIZONTAL",
				["leftOffset"] = 0,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 124,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["rigtOffset"] = 1,
				["textX"] = 0,
				["xTextOffset"] = 0,
				["topOffset"] = 0,
			},
			["model"] = {
				["clickThru"] = true,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 1,
				["justifyV"] = "CENTER",
				["frameStrata"] = 2,
				["width"] = 133,
				["y"] = -45,
				["x"] = -110,
				["justifyH"] = "CENTER",
				["rotation"] = 0,
				["anchor"] = "BottomLeft",
				["height"] = 197,
				["enable"] = false,
				["zoom"] = 0,
			},
			["height"] = 47,
			["buffs"] = {
				["frameStrata"] = 2,
				["alpha"] = 100,
				["columns"] = 7,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["rows"] = 2,
				["isLeftToRight"] = true,
				["isTopToBottom"] = false,
				["y"] = 48,
				["x"] = 2,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["enable"] = false,
				["showBG"] = false,
				["scale"] = 77,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 2,
				["width"] = 98,
				["y"] = 0,
				["x"] = 51,
				["justifyH"] = 1,
				["anchor"] = "Left",
				["frameStrata"] = 2,
				["height"] = 26,
				["scale"] = 100,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -52,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textX"] = 0,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["enable"] = true,
				["frameStrata"] = 2,
				["width"] = 51,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["alpha"] = 100,
				["x"] = -106,
				["textHori"] = 2,
				["textVert"] = 2,
				["topOffset"] = 0,
			},
		},
		["focustarget"] = {
			["overlay"] = {
				["y"] = 0,
				["x"] = 0,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["enable"] = false,
			},
			["debuffs"] = {
				["scale"] = 77,
				["frameStrata"] = 2,
				["columns"] = 7,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["rows"] = 2,
				["isLeftToRight"] = true,
				["x"] = -354,
				["y"] = 47,
				["isTopToBottom"] = false,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["enable"] = false,
				["showBG"] = false,
				["alpha"] = 100,
			},
			["resource"] = {
				["enable"] = true,
				["columns"] = 1,
				["compress"] = 0,
				["scale"] = 64,
				["height"] = 50,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = 12,
				["style"] = "Bar",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["angle"] = 0,
				["showBG"] = false,
				["isTopToBottom"] = false,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -52,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textX"] = 0,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 51,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["x"] = -106,
				["textHori"] = 2,
				["textVert"] = 2,
				["topOffset"] = 0,
			},
			["class"] = {
				["scale"] = 100,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -51,
				["x"] = 0,
				["drop"] = true,
				["height"] = 12,
				["anchor"] = "BottomLeft",
				["enable"] = true,
			},
			["cast"] = {
				["prevOrient"] = "HORIZONTAL",
				["multi"] = true,
				["textheight"] = 12,
				["backdropOpacity"] = 50,
				["arcMid"] = 0,
				["anchor"] = "Left",
				["showBG"] = false,
				["orient"] = "HORIZONTAL",
				["textAnchor"] = "Center",
				["frameLayer"] = 4,
				["yTextOffset"] = 0,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 22,
				["rotate"] = 0,
				["maxTextWidth"] = 98,
				["enable"] = true,
				["sparkY"] = 0,
				["Sparkarc"] = 0,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["frameLevel"] = 2,
				["alpha"] = 100,
				["x"] = 1,
				["frameStrata"] = 2,
				["width"] = 122,
				["y"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["textY"] = 0,
				["textureName"] = "Blizzard",
				["textX"] = 0,
				["anchorText"] = "Center",
			},
			["altPower"] = {
				["maxTextWidth"] = 1000,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["textVert"] = 2,
				["backdropOpacity"] = 50,
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textHori"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["mouseover"] = "value",
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["enable"] = true,
				["alpha"] = 100,
				["y"] = 0,
				["x"] = 2,
				["mouseOverTooltip"] = true,
				["anchor"] = "Right",
				["frameStrata"] = 2,
				["scale"] = 86,
			},
			["background"] = {
				["scale"] = 100,
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["b"] = 100,
					["g"] = 100,
					["r"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "Left",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 91,
				["y"] = 0,
				["x"] = 0,
				["height"] = 51,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["color"] = {
					["a"] = 0.5,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["enable"] = true,
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 2,
				["width"] = 25,
				["y"] = 0,
				["x"] = 0,
				["justifyH"] = 2,
				["height"] = 26,
				["frameStrata"] = 2,
				["enable"] = true,
				["anchor"] = "Left",
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = 12,
				["x"] = 0,
				["justifyH"] = 1,
				["height"] = 12,
				["frameStrata"] = 2,
				["anchor"] = "top",
				["enable"] = true,
			},
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["enable"] = true,
				["space"] = 0,
				["isLeftToRight"] = false,
				["scale"] = 78,
				["yArc"] = 0,
				["xFlex"] = 0,
				["frameLayer"] = 4,
				["spacing"] = 0,
				["anchor"] = "Right",
				["angle"] = 46,
				["rings"] = 1,
				["IsLeftToRight"] = false,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["compress"] = 0,
				["width"] = 55,
				["frameStrata"] = 2,
				["alpha"] = 100,
				["xArc"] = 0,
				["y"] = 0,
				["isTopToBottom"] = false,
				["style"] = "SQUARE",
				["reverse"] = true,
				["height"] = 55,
				["x"] = 0,
				["spin"] = 0,
				["IsTopToBottom"] = true,
			},
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 0.5,
				["anchor"] = "BottomLeft",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["x"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["leftOffset"] = 0,
				["textVert"] = 2,
				["textHori"] = 2,
				["enable"] = true,
				["maxTextWidth"] = 98,
				["alpha"] = 100,
				["width"] = 124,
				["textX"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["xTextOffset"] = 0,
				["y"] = -1,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["alpha"] = 0.6,
			["showInOverrideUI"] = false,
			["hidden"] = true,
			["width"] = 173,
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 2,
				["width"] = 98,
				["y"] = 0,
				["x"] = -51,
				["justifyH"] = 3,
				["anchor"] = "Right",
				["frameStrata"] = 2,
				["scale"] = 100,
				["height"] = 26,
			},
			["Health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["frameStrata"] = 2,
				["width"] = 51,
				["orient"] = "HORIZONTAL",
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["textY"] = 0,
				["textVert"] = 2,
				["alpha"] = 100,
				["topOffset"] = 0,
			},
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 1,
				["backdropOpacity"] = 0.5,
				["arcMid"] = 0,
				["anchor"] = "TopLeft",
				["format"] = "percent",
				["bottomOffset"] = 1,
				["frameLayer"] = 1,
				["mouseover"] = "current",
				["yTextOffset"] = 0,
				["x"] = 0,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["y"] = 0,
				["xTextOffset"] = 0,
				["textVert"] = 2,
				["textX"] = 0,
				["leftOffset"] = 0,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 124,
				["enable"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["maxTextWidth"] = 98,
				["rigtOffset"] = 1,
				["orient"] = "HORIZONTAL",
				["height"] = 12,
				["topOffset"] = 0,
			},
			["model"] = {
				["zoom"] = 0,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 1,
				["justifyV"] = "CENTER",
				["frameStrata"] = 2,
				["width"] = 133,
				["y"] = -45,
				["x"] = 110,
				["justifyH"] = "CENTER",
				["clickThru"] = true,
				["height"] = 197,
				["enable"] = false,
				["anchor"] = "BottomRight",
				["rotation"] = 0,
			},
			["height"] = 47,
			["buffs"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["frameStrata"] = 2,
				["columns"] = 7,
				["frameLayer"] = 1,
				["scale"] = 77,
				["rows"] = 2,
				["isLeftToRight"] = true,
				["isTopToBottom"] = false,
				["y"] = 48,
				["x"] = -2,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["enable"] = false,
				["showBG"] = false,
				["alpha"] = 100,
			},
			["scale"] = 1.02,
			["Class"] = {
				["textY"] = 0,
				["prevOrient"] = "HORIZONTAL",
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "TopLeft",
				["format"] = "value",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["orient"] = "HORIZONTAL",
				["textVert"] = 2,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -41,
				["x"] = 106,
				["mouseover"] = "value",
				["height"] = 12,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textX"] = 0,
			},
		},
		["targettarget"] = {
			["overlay"] = {
				["y"] = 0,
				["x"] = 0,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["enable"] = false,
			},
			["debuffs"] = {
				["scale"] = 77,
				["rows"] = 2,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["showBG"] = false,
				["columns"] = 7,
				["frameLayer"] = 1,
				["alpha"] = 100,
				["y"] = -80,
				["x"] = 13,
				["frameStrata"] = 2,
				["reverse"] = false,
				["enable"] = true,
				["isLeftToRight"] = true,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["isTopToBottom"] = true,
			},
			["resource"] = {
				["enable"] = true,
				["columns"] = 1,
				["compress"] = 0,
				["scale"] = 100,
				["height"] = 50,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = 12,
				["style"] = "Bar",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["angle"] = 0,
				["showBG"] = false,
				["isTopToBottom"] = false,
			},
			["scale"] = 1,
			["Class"] = {
				["textY"] = 0,
				["prevOrient"] = "HORIZONTAL",
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "TopLeft",
				["format"] = "value",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["orient"] = "HORIZONTAL",
				["textVert"] = 2,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -41,
				["x"] = 106,
				["mouseover"] = "value",
				["height"] = 12,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textX"] = 0,
			},
			["padW"] = 1,
			["altPower"] = {
				["maxTextWidth"] = 1000,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["textVert"] = 2,
				["backdropOpacity"] = 50,
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textHori"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["mouseover"] = "value",
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["enable"] = true,
				["alpha"] = 100,
				["y"] = 11,
				["x"] = -43,
				["mouseOverTooltip"] = true,
				["anchor"] = "BottomRight",
				["frameStrata"] = 2,
				["scale"] = 62,
			},
			["background"] = {
				["scale"] = 100,
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["b"] = 100,
					["g"] = 100,
					["r"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "Left",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 100,
				["y"] = 0,
				["x"] = 1,
				["height"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["color"] = {
					["a"] = 0.5,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["enable"] = false,
			},
			["class"] = {
				["scale"] = 100,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -51,
				["x"] = 0,
				["drop"] = true,
				["height"] = 12,
				["anchor"] = "BottomLeft",
				["enable"] = true,
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = -7,
				["x"] = 0,
				["justifyH"] = 1,
				["height"] = 12,
				["frameStrata"] = 2,
				["anchor"] = "Bottom",
				["enable"] = true,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -52,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textX"] = 0,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["enable"] = false,
				["alpha"] = 100,
				["width"] = 51,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["x"] = -106,
				["textHori"] = 2,
				["textVert"] = 2,
				["topOffset"] = 0,
			},
			["power"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 34,
				["anchor"] = "BottomLeft",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 153,
				["anchorText"] = "Right",
				["percent"] = true,
				["maxTextWidth"] = 98,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "GlowArc",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\GlowArc.tga",
				["LifeTime"] = 0,
				["textHori"] = 2,
				["rotate"] = true,
				["leftOffset"] = 0,
				["scale"] = 100,
				["alpha"] = 100,
				["textY"] = 99,
				["frameStrata"] = 2,
				["width"] = 59,
				["textX"] = -100,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["x"] = 51,
				["y"] = 29,
				["textVert"] = 2,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 79,
				["y"] = -15,
				["x"] = -8,
				["justifyH"] = 3,
				["anchor"] = "Right",
				["frameStrata"] = 2,
				["scale"] = 100,
				["height"] = 40,
			},
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["enable"] = true,
				["space"] = 0,
				["isLeftToRight"] = false,
				["scale"] = 80,
				["yArc"] = 0,
				["xFlex"] = 0,
				["frameLayer"] = 1,
				["spacing"] = -2,
				["anchor"] = "BottomRight",
				["angle"] = 111,
				["rings"] = 1,
				["IsLeftToRight"] = false,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 1,
				["compress"] = 58,
				["width"] = 96,
				["frameStrata"] = 2,
				["alpha"] = 100,
				["xArc"] = 0,
				["y"] = 22,
				["isTopToBottom"] = true,
				["style"] = "ROUND",
				["reverse"] = true,
				["height"] = 200,
				["x"] = -3,
				["spin"] = 0,
				["IsTopToBottom"] = true,
			},
			["width"] = 105,
			["padH"] = 1,
			["health"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 40,
				["arcMid"] = 0,
				["anchor"] = "BottomLeft",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["x"] = 47,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Left",
				["percent"] = true,
				["maxTextWidth"] = 98,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "GlowArc",
				["LifeTime"] = 0,
				["justifyH"] = "CENTER",
				["drop"] = true,
				["bottomOffset"] = 100,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\GlowArc.tga",
				["y"] = 22,
				["rotate"] = true,
				["textVert"] = 2,
				["leftOffset"] = 0,
				["enable"] = true,
				["textY"] = 100,
				["frameStrata"] = 2,
				["alpha"] = 100,
				["width"] = 76,
				["classColor"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["textX"] = -11,
				["rigtOffset"] = 1,
				["height"] = 165,
				["xTextOffset"] = 0,
				["topOffset"] = 55,
			},
			["Health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["frameStrata"] = 2,
				["width"] = 51,
				["orient"] = "HORIZONTAL",
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["textY"] = 0,
				["textVert"] = 2,
				["alpha"] = 100,
				["topOffset"] = 0,
			},
			["model"] = {
				["zoom"] = 0,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 120,
				["justifyV"] = "CENTER",
				["frameStrata"] = 1,
				["width"] = 110,
				["y"] = 29,
				["x"] = -8,
				["justifyH"] = "CENTER",
				["clickThru"] = true,
				["height"] = 134,
				["enable"] = true,
				["anchor"] = "BottomRight",
				["rotation"] = 0,
			},
			["height"] = 10,
			["buffs"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["rows"] = 9,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["showBG"] = false,
				["columns"] = 3,
				["frameLayer"] = 1,
				["alpha"] = 100,
				["y"] = -27,
				["x"] = 78,
				["frameStrata"] = 2,
				["reverse"] = false,
				["scale"] = 77,
				["isLeftToRight"] = true,
				["enable"] = true,
				["isTopToBottom"] = false,
			},
			["cast"] = {
				["prevOrient"] = "VERTICAL",
				["multi"] = true,
				["textheight"] = 12,
				["backdropOpacity"] = 40,
				["arcMid"] = 0,
				["anchor"] = "BottomLeft",
				["showBG"] = true,
				["orient"] = "VERTICAL",
				["textAnchor"] = "Left",
				["frameLayer"] = 2,
				["yTextOffset"] = 0,
				["xTextOffset"] = 24,
				["arc"] = 0,
				["height"] = 128,
				["rotate"] = true,
				["maxTextWidth"] = 199,
				["enable"] = true,
				["sparkY"] = 1,
				["Sparkarc"] = -72,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\GlowArc.tga",
				["frameLevel"] = 2,
				["alpha"] = 100,
				["x"] = 62,
				["frameStrata"] = 2,
				["width"] = 67,
				["y"] = 42,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["scale"] = 100,
				["textY"] = 37,
				["textureName"] = "GlowArc",
				["textX"] = 30,
				["anchorText"] = "TopRight",
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 2,
				["width"] = 25,
				["y"] = 9,
				["x"] = -24,
				["justifyH"] = 2,
				["height"] = 26,
				["frameStrata"] = 2,
				["enable"] = true,
				["anchor"] = "Right",
			},
		},
		["boss4"] = {
			["overlay"] = {
				["y"] = 0,
				["x"] = 0,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["enable"] = false,
			},
			["debuffs"] = {
				["frameStrata"] = 2,
				["isLeftToRight"] = true,
				["columns"] = 7,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["rows"] = 2,
				["alpha"] = 100,
				["x"] = -354,
				["y"] = 47,
				["isTopToBottom"] = false,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["enable"] = false,
				["showBG"] = false,
				["scale"] = 77,
			},
			["resource"] = {
				["enable"] = true,
				["columns"] = 1,
				["compress"] = 0,
				["scale"] = 64,
				["height"] = 50,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = 12,
				["style"] = "Bar",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["angle"] = 0,
				["showBG"] = false,
				["isTopToBottom"] = false,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -52,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textX"] = 0,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 51,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["x"] = -106,
				["textHori"] = 2,
				["textVert"] = 2,
				["topOffset"] = 0,
			},
			["class"] = {
				["scale"] = 100,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -51,
				["x"] = 0,
				["drop"] = true,
				["height"] = 12,
				["anchor"] = "BottomLeft",
				["enable"] = true,
			},
			["cast"] = {
				["prevOrient"] = "HORIZONTAL",
				["multi"] = true,
				["textheight"] = 12,
				["backdropOpacity"] = 50,
				["arcMid"] = 0,
				["anchor"] = "Left",
				["showBG"] = false,
				["orient"] = "HORIZONTAL",
				["textAnchor"] = "Center",
				["frameLayer"] = 4,
				["yTextOffset"] = 0,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 22,
				["rotate"] = 0,
				["maxTextWidth"] = 98,
				["scale"] = 100,
				["sparkY"] = 0,
				["Sparkarc"] = 0,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["frameLevel"] = 2,
				["alpha"] = 100,
				["x"] = 1,
				["frameStrata"] = 2,
				["width"] = 122,
				["y"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["enable"] = true,
				["textY"] = 0,
				["textureName"] = "Blizzard",
				["textX"] = 0,
				["anchorText"] = "Center",
			},
			["altPower"] = {
				["maxTextWidth"] = 1000,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["textVert"] = 2,
				["backdropOpacity"] = 50,
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textHori"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["mouseover"] = "value",
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["scale"] = 86,
				["alpha"] = 100,
				["y"] = 0,
				["x"] = 2,
				["mouseOverTooltip"] = true,
				["anchor"] = "Right",
				["frameStrata"] = 2,
				["enable"] = true,
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 2,
				["width"] = 25,
				["y"] = 0,
				["x"] = 0,
				["justifyH"] = 2,
				["height"] = 26,
				["frameStrata"] = 2,
				["anchor"] = "Left",
				["enable"] = true,
			},
			["background"] = {
				["scale"] = 100,
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["r"] = 100,
					["g"] = 100,
					["b"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "Left",
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 91,
				["y"] = 0,
				["x"] = 0,
				["height"] = 51,
				["inset"] = 0,
				["enable"] = true,
				["color"] = {
					["a"] = 0.5,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = 12,
				["x"] = 0,
				["justifyH"] = 1,
				["height"] = 12,
				["frameStrata"] = 2,
				["enable"] = true,
				["anchor"] = "top",
			},
			["padW"] = 0,
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 0.5,
				["anchor"] = "BottomLeft",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["x"] = 0,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["enable"] = true,
				["maxTextWidth"] = 98,
				["alpha"] = 100,
				["width"] = 124,
				["textVert"] = 2,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["xTextOffset"] = 0,
				["y"] = -1,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 1,
				["backdropOpacity"] = 0.5,
				["arcMid"] = 0,
				["anchor"] = "TopLeft",
				["format"] = "percent",
				["bottomOffset"] = 1,
				["frameLayer"] = 1,
				["mouseover"] = "current",
				["yTextOffset"] = 0,
				["x"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["y"] = 0,
				["xTextOffset"] = 0,
				["textX"] = 0,
				["textVert"] = 2,
				["leftOffset"] = 0,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 124,
				["enable"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["maxTextWidth"] = 98,
				["rigtOffset"] = 1,
				["orient"] = "HORIZONTAL",
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["spin"] = 0,
				["scale"] = 78,
				["space"] = 0,
				["IsLeftToRight"] = false,
				["enable"] = true,
				["alpha"] = 100,
				["xFlex"] = 0,
				["frameLayer"] = 4,
				["spacing"] = 0,
				["anchor"] = "Right",
				["angle"] = 46,
				["isTopToBottom"] = false,
				["yArc"] = 0,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["compress"] = 0,
				["width"] = 55,
				["isLeftToRight"] = false,
				["frameStrata"] = 2,
				["xArc"] = 0,
				["y"] = 0,
				["x"] = 0,
				["style"] = "SQUARE",
				["reverse"] = true,
				["height"] = 55,
				["IsTopToBottom"] = true,
				["yShift"] = 0,
				["rings"] = 1,
			},
			["width"] = 173,
			["padH"] = 0,
			["Health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["frameStrata"] = 2,
				["width"] = 51,
				["orient"] = "HORIZONTAL",
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["textY"] = 0,
				["textVert"] = 2,
				["alpha"] = 100,
				["topOffset"] = 0,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 2,
				["width"] = 98,
				["y"] = 0,
				["x"] = -51,
				["justifyH"] = 3,
				["anchor"] = "Right",
				["frameStrata"] = 2,
				["height"] = 26,
				["scale"] = 100,
			},
			["model"] = {
				["clickThru"] = true,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 1,
				["justifyV"] = "CENTER",
				["frameStrata"] = 2,
				["width"] = 133,
				["y"] = -45,
				["x"] = 110,
				["justifyH"] = "CENTER",
				["rotation"] = 0,
				["anchor"] = "BottomRight",
				["height"] = 197,
				["enable"] = false,
				["zoom"] = 0,
			},
			["height"] = 47,
			["buffs"] = {
				["frameStrata"] = 2,
				["isLeftToRight"] = true,
				["columns"] = 7,
				["frameLayer"] = 1,
				["scale"] = 77,
				["rows"] = 2,
				["alpha"] = 100,
				["isTopToBottom"] = false,
				["y"] = 48,
				["x"] = -2,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["enable"] = false,
				["showBG"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
			},
			["scale"] = 1,
			["Class"] = {
				["textY"] = 0,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "TopLeft",
				["format"] = "value",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["orient"] = "HORIZONTAL",
				["textX"] = 0,
				["scale"] = 100,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -41,
				["x"] = 106,
				["mouseover"] = "value",
				["height"] = 12,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textVert"] = 2,
			},
		},
		["player"] = {
			["overlay"] = {
				["y"] = 0,
				["x"] = 0,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["enable"] = false,
			},
			["debuffs"] = {
				["scale"] = 76,
				["frameStrata"] = 2,
				["columns"] = 6,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["rows"] = 3,
				["isLeftToRight"] = true,
				["x"] = 42,
				["y"] = 69,
				["isTopToBottom"] = true,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Bottom",
				["enable"] = false,
				["showBG"] = false,
				["alpha"] = 100,
			},
			["resource"] = {
				["rotateIcons"] = 46,
				["enable"] = true,
				["spacing"] = 6,
				["anchor"] = "Bottom",
				["angle"] = 122,
				["showBG"] = false,
				["columns"] = 5,
				["compress"] = 30,
				["frameStrata"] = 2,
				["frameLayer"] = 1,
				["isLeftToRight"] = true,
				["width"] = 149,
				["y"] = 28,
				["x"] = 0,
				["style"] = "Bar",
				["scale"] = 100,
				["height"] = 175,
				["isTopToBottom"] = true,
				["alpha"] = 100,
				["color"] = {
					["a"] = 1,
					["b"] = 1,
					["g"] = 1,
					["r"] = 1,
				},
			},
			["altpower"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "BottomRight",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -185,
				["x"] = 163,
				["arc"] = 0,
				["height"] = 192,
				["rotate"] = true,
				["percent"] = true,
				["maxTextWidth"] = 300,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Bar",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["LifeTime"] = 0,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\Bar.tga",
				["xTextOffset"] = 0,
				["textX"] = 33,
				["reverseArc"] = false,
				["textVert"] = 2,
				["bottomOffset"] = 100,
				["alpha"] = 100,
				["textY"] = 4,
				["frameStrata"] = 1,
				["width"] = 162,
				["scale"] = 96,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["anchorText"] = "TopLeft",
				["textHori"] = 2,
				["leftOffset"] = 0,
				["yTextOffset"] = 0,
				["topOffset"] = 0,
			},
			["class"] = {
				["textY"] = -8,
				["enable"] = true,
				["sparkConfig"] = false,
				["textureName"] = "Bar",
				["arcMid"] = -9,
				["anchor"] = "Center",
				["arcEnd"] = 47,
				["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
				["textX"] = 0,
				["alpha"] = 100,
				["width"] = 207,
				["y"] = -5,
				["sparkSize"] = 39,
				["height"] = 64,
				["drop"] = false,
				["x"] = 0,
				["scale"] = 100,
			},
			["cast"] = {
				["prevOrient"] = "HORIZONTAL",
				["multi"] = true,
				["textheight"] = 166,
				["backdropOpacity"] = 100,
				["arcMid"] = 5,
				["anchor"] = "Top",
				["showBG"] = true,
				["orient"] = "HORIZONTAL",
				["textAnchor"] = "Center",
				["frameLayer"] = 3,
				["y"] = -3,
				["x"] = 0,
				["arc"] = 37,
				["height"] = 107,
				["anchorText"] = "Center",
				["textY"] = 30,
				["enable"] = true,
				["sparkConfig"] = false,
				["textureName"] = "Bar",
				["Sparkarc"] = -69,
				["drop"] = false,
				["arcEnd"] = -135.303436279297,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\Bar.tga",
				["reverseArc"] = false,
				["frameLevel"] = 13,
				["rotate"] = false,
				["alpha"] = 100,
				["frameStrata"] = 1,
				["width"] = 162,
				["maxTextWidth"] = 289,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["scale"] = 100,
				["sparkY"] = 1,
				["xTextOffset"] = 0,
				["textX"] = 0,
				["yTextOffset"] = 0,
			},
			["altPower"] = {
				["maxTextWidth"] = 1000,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["textVert"] = 2,
				["backdropOpacity"] = 50,
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textHori"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["mouseover"] = "value",
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
			},
			["Goal"] = {
				["Ancient Mana"] = 180,
				["Artifact Points"] = 9100,
				["Gold"] = 4000,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["enable"] = false,
				["alpha"] = 100,
				["y"] = 0,
				["x"] = -36,
				["mouseOverTooltip"] = true,
				["anchor"] = "Left",
				["frameStrata"] = 2,
				["scale"] = 80,
			},
			["Class"] = {
				["textY"] = 0,
				["prevOrient"] = "HORIZONTAL",
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "BottomRight",
				["format"] = "value",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["orient"] = "HORIZONTAL",
				["textVert"] = 2,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = 41,
				["x"] = -106,
				["mouseover"] = "value",
				["height"] = 12,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textX"] = 0,
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 2,
				["width"] = 25,
				["y"] = 0,
				["x"] = 25,
				["justifyH"] = 2,
				["anchor"] = "Right",
				["frameStrata"] = 1,
				["height"] = 26,
				["enable"] = true,
			},
			["scale"] = 0.9,
			["power"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 100,
				["anchor"] = "BottomRight",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -185,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 192,
				["anchorText"] = "TopLeft",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Bar",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["LifeTime"] = 0,
				["arcEnd"] = 4,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\Bar.tga",
				["yTextOffset"] = 0,
				["x"] = 138,
				["reverseArc"] = false,
				["leftOffset"] = 0,
				["textVert"] = 2,
				["textY"] = -10,
				["alpha"] = 100,
				["frameStrata"] = 1,
				["width"] = 162,
				["scale"] = 96,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["rotate"] = true,
				["textHori"] = 3,
				["textX"] = 66,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 3,
				["width"] = 35,
				["y"] = 11,
				["x"] = 0,
				["justifyH"] = 3,
				["height"] = 12,
				["frameStrata"] = 2,
				["anchor"] = "Bottom",
				["enable"] = true,
			},
			["icons"] = {
				["xShift"] = 0,
				["spin"] = -102,
				["rev"] = false,
				["space"] = -13,
				["scale"] = 83,
				["enable"] = true,
				["yShift"] = 0,
				["offset"] = -17,
				["columns"] = 11,
				["frameLayer"] = 55,
				["isTopToBottom"] = true,
				["spacing"] = 13,
				["anchor"] = "Bottom",
				["angle"] = 304,
				["frameStrata"] = 8,
				["width"] = 42,
				["xFlex"] = 0,
				["yFlex"] = 0,
				["s"] = false,
				["compress"] = 67,
				["alpha"] = 100,
				["IsLeftToRight"] = false,
				["yArc"] = 0,
				["xArc"] = 0,
				["y"] = 21,
				["x"] = -15,
				["style"] = "BAR",
				["reverse"] = false,
				["height"] = 44,
				["isLeftToRight"] = false,
				["IsTopToBottom"] = true,
				["rings"] = 4,
			},
			["frameLayer"] = 4,
			["Health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["frameStrata"] = 2,
				["width"] = 51,
				["orient"] = "HORIZONTAL",
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["textY"] = 0,
				["textVert"] = 2,
				["alpha"] = 100,
				["topOffset"] = 0,
			},
			["showInOverrideUI"] = false,
			["alpha"] = 0.8,
			["width"] = 235,
			["health"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 100,
				["arcMid"] = 0,
				["anchor"] = "BottomLeft",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["x"] = -138,
				["arc"] = 0,
				["textHori"] = 3,
				["anchorText"] = "TopRight",
				["percent"] = true,
				["textY"] = 6,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Bar2",
				["LifeTime"] = 0,
				["rotate"] = true,
				["justifyH"] = "CENTER",
				["drop"] = true,
				["bottomOffset"] = 100,
				["arcEnd"] = 37.0818939208984,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\Bar2.tga",
				["y"] = -185,
				["textVert"] = 1,
				["reverseArc"] = false,
				["textX"] = -45,
				["leftOffset"] = 0,
				["maxTextWidth"] = 300,
				["frameStrata"] = 1,
				["alpha"] = 100,
				["width"] = 162,
				["classColor"] = false,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["scale"] = 96,
				["rigtOffset"] = 1,
				["xTextOffset"] = 0,
				["height"] = 192,
				["topOffset"] = 0,
			},
			["frameStrata"] = 4,
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 219,
				["y"] = 0,
				["x"] = 8,
				["justifyH"] = 2,
				["height"] = 12,
				["frameStrata"] = 1,
				["anchor"] = "Left",
				["scale"] = 100,
			},
			["model"] = {
				["zoom"] = 98,
				["frameLevel"] = 1,
				["frameLayer"] = 3,
				["scale"] = 51,
				["justifyV"] = "CENTER",
				["frameStrata"] = 2,
				["width"] = 307,
				["y"] = 45,
				["x"] = -110,
				["justifyH"] = "CENTER",
				["clickThru"] = true,
				["height"] = 207,
				["enable"] = false,
				["anchor"] = "TopLeft",
				["rotation"] = 0,
			},
			["height"] = 10,
			["buffs"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["frameStrata"] = 2,
				["columns"] = 7,
				["frameLayer"] = 1,
				["scale"] = 64,
				["rows"] = 2,
				["isLeftToRight"] = true,
				["isTopToBottom"] = false,
				["y"] = 35,
				["x"] = 31,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "TopLeft",
				["enable"] = false,
				["showBG"] = true,
				["alpha"] = 100,
			},
			["currency"] = {
				["scale"] = 64,
				["Goal"] = {
					["Ancient Mana"] = 400,
					["Artifact Points"] = 14400,
				},
				["AutoWatch"] = true,
				["lifeTime_Track"] = {
					["Ancient Mana"] = {
						10, -- [1]
						4, -- [2]
						1, -- [3]
						6, -- [4]
						7, -- [5]
						8, -- [6]
						9, -- [7]
						10, -- [8]
						11, -- [9]
						14, -- [10]
						15, -- [11]
						16, -- [12]
						18, -- [13]
						30, -- [14]
						33, -- [15]
						35, -- [16]
						41, -- [17]
						45, -- [18]
						48, -- [19]
						53, -- [20]
						43, -- [21]
						45, -- [22]
						47, -- [23]
						48, -- [24]
						53, -- [25]
						55, -- [26]
						59, -- [27]
						61, -- [28]
						62, -- [29]
						64, -- [30]
						65, -- [31]
						66, -- [32]
						67, -- [33]
						1, -- [34]
						2, -- [35]
						3, -- [36]
						4, -- [37]
						154, -- [38]
						157, -- [39]
						159, -- [40]
						161, -- [41]
						165, -- [42]
						167, -- [43]
						168, -- [44]
						169, -- [45]
						171, -- [46]
						173, -- [47]
						175, -- [48]
						125, -- [49]
						-275, -- [50]
						-269, -- [51]
						-232, -- [52]
						-230, -- [53]
						-280, -- [54]
						-133, -- [55]
						-93, -- [56]
						-62, -- [57]
						-112, -- [58]
						-99, -- [59]
						27, -- [60]
						64, -- [61]
						104, -- [62]
						3, -- [63]
						4, -- [64]
						6, -- [65]
						31, -- [66]
						33, -- [67]
						36, -- [68]
						39, -- [69]
						41, -- [70]
						42, -- [71]
						44, -- [72]
						46, -- [73]
						48, -- [74]
						49, -- [75]
						56, -- [76]
						58, -- [77]
						61, -- [78]
						62, -- [79]
						63, -- [80]
						64, -- [81]
						65, -- [82]
						66, -- [83]
						71, -- [84]
						72, -- [85]
						74, -- [86]
						75, -- [87]
						77, -- [88]
						81, -- [89]
						82, -- [90]
						85, -- [91]
						35, -- [92]
						41, -- [93]
						43, -- [94]
						44, -- [95]
						46, -- [96]
						-50, -- [97]
						-450, -- [98]
						-440, -- [99]
						10, -- [100]
						12, -- [101]
						14, -- [102]
						-1, -- [103]
						9, -- [104]
						11, -- [105]
						12, -- [106]
						22, -- [107]
						23, -- [108]
						25, -- [109]
						27, -- [110]
						28, -- [111]
						29, -- [112]
						39, -- [113]
						49, -- [114]
						50, -- [115]
						51, -- [116]
						53, -- [117]
						54, -- [118]
						55, -- [119]
						2, -- [120]
						6, -- [121]
						3, -- [122]
						4, -- [123]
						54, -- [124]
						1, -- [125]
						2, -- [126]
						3, -- [127]
						53, -- [128]
						103, -- [129]
						105, -- [130]
						111, -- [131]
						115, -- [132]
						116, -- [133]
						122, -- [134]
						222, -- [135]
						322, -- [136]
						372, -- [137]
						376, -- [138]
						377, -- [139]
						327, -- [140]
						336, -- [141]
						337, -- [142]
						537, -- [143]
						-5, -- [144]
						-10, -- [145]
						-15, -- [146]
						-40, -- [147]
						-45, -- [148]
						60, -- [149]
						124, -- [150]
						187, -- [151]
						182, -- [152]
						183, -- [153]
						184, -- [154]
						187, -- [155]
						191, -- [156]
						193, -- [157]
						194, -- [158]
						196, -- [159]
						197, -- [160]
						199, -- [161]
						265, -- [162]
						324, -- [163]
						-476, -- [164]
						-475, -- [165]
						-473, -- [166]
						-472, -- [167]
						2, -- [168]
						4, -- [169]
						5, -- [170]
						6, -- [171]
						7, -- [172]
						-18, -- [173]
						-16, -- [174]
						1, -- [175]
						2, -- [176]
						30, -- [177]
						51, -- [178]
						10, -- [179]
						11, -- [180]
						-39, -- [181]
						-89, -- [182]
						-139, -- [183]
					},
					["Order Resources"] = {
						68, -- [1]
						127, -- [2]
						186, -- [3]
						247, -- [4]
						177, -- [5]
						117, -- [6]
						32, -- [7]
						-150, -- [8]
						46, -- [9]
						-250, -- [10]
						-500, -- [11]
						4500, -- [12]
						2500, -- [13]
						2000, -- [14]
						1500, -- [15]
						1538, -- [16]
						1587, -- [17]
					},
					["Artifact Points"] = {
						150, -- [1]
						300, -- [2]
						525, -- [3]
						1200, -- [4]
						1350, -- [5]
						1500, -- [6]
						2025, -- [7]
						2175, -- [8]
						2700, -- [9]
						2850, -- [10]
						4350, -- [11]
						4500, -- [12]
						4650, -- [13]
						4800, -- [14]
						5775, -- [15]
						5925, -- [16]
						6495, -- [17]
						6532, -- [18]
						6607, -- [19]
						6682, -- [20]
						6757, -- [21]
						6832, -- [22]
						6907, -- [23]
						7047, -- [24]
						7122, -- [25]
						-4158, -- [26]
						245, -- [27]
						260, -- [28]
						320, -- [29]
						460, -- [30]
						150, -- [31]
						260, -- [32]
						410, -- [33]
						560, -- [34]
						150, -- [35]
						600, -- [36]
						1050, -- [37]
						1200, -- [38]
						2100, -- [39]
						975, -- [40]
						1500, -- [41]
						2400, -- [42]
						2640, -- [43]
						3480, -- [44]
						3720, -- [45]
						3960, -- [46]
						4200, -- [47]
						4260, -- [48]
						4380, -- [49]
					},
					["Gold"] = {
						0, -- [1]
						-194, -- [2]
						-156, -- [3]
						-11000, -- [4]
						-11000, -- [5]
						-11000, -- [6]
						-22000, -- [7]
						-33000, -- [8]
						-22000, -- [9]
						-11000, -- [10]
						-33000, -- [11]
						38800, -- [12]
						232800, -- [13]
						-30000, -- [14]
						-60000, -- [15]
						-90000, -- [16]
						-120000, -- [17]
						-180000, -- [18]
						-240000, -- [19]
						-180000, -- [20]
						194000, -- [21]
						388000, -- [22]
						364990, -- [23]
						574810, -- [24]
						768810, -- [25]
						962810, -- [26]
						1156810, -- [27]
						1350810, -- [28]
						1544810, -- [29]
						1738810, -- [30]
						2126810, -- [31]
						2115810, -- [32]
						3997, -- [33]
						11034, -- [34]
						20221, -- [35]
						30092, -- [36]
						224092, -- [37]
						418092, -- [38]
						612092, -- [39]
						294094, -- [40]
						428201, -- [41]
						531201, -- [42]
						737201, -- [43]
						943201, -- [44]
						1149201, -- [45]
						1355201, -- [46]
						1361386, -- [47]
						1567386, -- [48]
						1773386, -- [49]
						1979386, -- [50]
						1988385, -- [51]
						1998546, -- [52]
						2002436, -- [53]
						2014299, -- [54]
						2016204, -- [55]
						2030482, -- [56]
						2034521, -- [57]
						2039303, -- [58]
						2245303, -- [59]
						2371561, -- [60]
						2371645, -- [61]
						2191645, -- [62]
						1291645, -- [63]
						1280645, -- [64]
						1290495, -- [65]
						1205674, -- [66]
						2162297, -- [67]
						2162313, -- [68]
						2162326, -- [69]
						2162360, -- [70]
						2162840, -- [71]
						2162858, -- [72]
						2162872, -- [73]
						2162885, -- [74]
						2259885, -- [75]
						2237885, -- [76]
						2226885, -- [77]
						2218651, -- [78]
						2220849, -- [79]
						2426849, -- [80]
						5873508, -- [81]
						5840508, -- [82]
						3241624, -- [83]
						-255451, -- [84]
						-224212, -- [85]
						-218601, -- [86]
						-285379, -- [87]
						712517, -- [88]
						712521, -- [89]
						712523, -- [90]
						712541, -- [91]
						712544, -- [92]
						-286525, -- [93]
						-73773, -- [94]
						-40, -- [95]
						-34854, -- [96]
						-34305, -- [97]
						-34234, -- [98]
						-27234, -- [99]
						-27226, -- [100]
						-27224, -- [101]
						-27223, -- [102]
						-27136, -- [103]
						-27121, -- [104]
						-174556, -- [105]
						-328315, -- [106]
						-523454, -- [107]
						-519454, -- [108]
						-528254, -- [109]
						-528175, -- [110]
						-147435, -- [111]
						-342574, -- [112]
						-496333, -- [113]
						194000, -- [114]
						161000, -- [115]
						-515629, -- [116]
						-505574, -- [117]
						-498917, -- [118]
						-496474, -- [119]
						-484840, -- [120]
						-480748, -- [121]
						-477606, -- [122]
						-475614, -- [123]
						-470051, -- [124]
						-447893, -- [125]
						-436620, -- [126]
						-434572, -- [127]
						-427249, -- [128]
						-422526, -- [129]
						-419047, -- [130]
						-225047, -- [131]
						-221734, -- [132]
						-219101, -- [133]
						100524, -- [134]
						108928, -- [135]
						123770, -- [136]
						317770, -- [137]
						18237, -- [138]
						22970, -- [139]
						-1656571, -- [140]
						-1654384, -- [141]
						-1404384, -- [142]
						-1654384, -- [143]
						-1654484, -- [144]
						-1808243, -- [145]
						-2003382, -- [146]
						-2004102, -- [147]
						-2004282, -- [148]
						-2005782, -- [149]
						-2005882, -- [150]
						-2005982, -- [151]
						-2006082, -- [152]
						-2006182, -- [153]
						137150, -- [154]
						143259, -- [155]
						152820, -- [156]
						163159, -- [157]
						170937, -- [158]
						-345464, -- [159]
						259212, -- [160]
						10235, -- [161]
						20308, -- [162]
						22240, -- [163]
						216240, -- [164]
						313240, -- [165]
						333404, -- [166]
						344619, -- [167]
						75357, -- [168]
						81918, -- [169]
						91248, -- [170]
						-162417, -- [171]
						-114032, -- [172]
						-102100, -- [173]
						-113100, -- [174]
						92900, -- [175]
						6001, -- [176]
						8383, -- [177]
						25564, -- [178]
						-536928, -- [179]
						-480137, -- [180]
						-480129, -- [181]
						-480118, -- [182]
						-479908, -- [183]
						-479894, -- [184]
						-479834, -- [185]
						-473534, -- [186]
						-218151, -- [187]
						-210323, -- [188]
						-207657, -- [189]
						-204677, -- [190]
						-189135, -- [191]
						-181311, -- [192]
						-171978, -- [193]
						34022, -- [194]
						43338, -- [195]
						249338, -- [196]
						203118, -- [197]
						210935, -- [198]
						221720, -- [199]
						210720, -- [200]
						80961, -- [201]
						102594, -- [202]
						111901, -- [203]
						135108, -- [204]
						147363, -- [205]
						153951, -- [206]
						-122592, -- [207]
						7133, -- [208]
						12245, -- [209]
						23934, -- [210]
						38122, -- [211]
						28772, -- [212]
						19422, -- [213]
						-261558, -- [214]
						439989, -- [215]
						422389, -- [216]
						-35200, -- [217]
						158800, -- [218]
						136800, -- [219]
						718800, -- [220]
						738200, -- [221]
						932200, -- [222]
						1126200, -- [223]
						1320200, -- [224]
						1902200, -- [225]
						1861046, -- [226]
						1940934, -- [227]
						1941024, -- [228]
						1941054, -- [229]
						1941144, -- [230]
						1941150, -- [231]
						1941360, -- [232]
						1941370, -- [233]
						1941400, -- [234]
						1941402, -- [235]
						1942602, -- [236]
						2106164, -- [237]
						2425432, -- [238]
						3542846, -- [239]
						3651882, -- [240]
						1211889, -- [241]
						1203089, -- [242]
						1220239, -- [243]
						1228050, -- [244]
						1434050, -- [245]
						412000, -- [246]
						606000, -- [247]
						800000, -- [248]
						994000, -- [249]
						194000, -- [250]
						388000, -- [251]
						-981703, -- [252]
						-585264, -- [253]
					},
				},
				["showBG"] = false,
				["anchor"] = "Bottom",
				["enable"] = true,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
				["isTopToBottom"] = false,
				["alpha"] = 100,
				["width"] = 164,
				["y"] = -160,
				["ThisSession"] = {
					["Ancient Mana"] = 0,
					["Order Resources"] = 0,
					["Artifact Points"] = 4380,
					["Gold"] = 0,
					["Nethershard"] = 0,
				},
				["x"] = -7,
				["frameStrata"] = 2,
				["height"] = 54,
				["advLog"] = true,
				["watchIndex"] = 3,
				["lifeTime"] = {
					["Ancient Mana"] = -178,
					["Order Resources"] = 1515,
					["Artifact Points"] = 6887,
					["Gold"] = 5816753,
					["Nethershard"] = 0,
				},
			},
			["background"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["b"] = 100,
					["g"] = 100,
					["r"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "Center",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 1,
				["width"] = 94,
				["y"] = 1,
				["x"] = 0,
				["height"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["scale"] = 100,
				["enable"] = false,
			},
		},
		["target"] = {
			["overlay"] = {
				["y"] = 0,
				["x"] = 0,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["enable"] = false,
			},
			["debuffs"] = {
				["scale"] = 77,
				["frameStrata"] = 2,
				["columns"] = 7,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["rows"] = 2,
				["isLeftToRight"] = false,
				["x"] = -13,
				["y"] = -80,
				["isTopToBottom"] = true,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["enable"] = true,
				["showBG"] = false,
				["alpha"] = 100,
			},
			["resource"] = {
				["enable"] = true,
				["columns"] = 1,
				["compress"] = 0,
				["scale"] = 64,
				["height"] = 50,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = 12,
				["style"] = "Bar",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["angle"] = 0,
				["showBG"] = false,
				["isTopToBottom"] = false,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -52,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textX"] = 0,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["enable"] = false,
				["alpha"] = 100,
				["width"] = 51,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["x"] = -106,
				["textHori"] = 2,
				["textVert"] = 2,
				["topOffset"] = 0,
			},
			["class"] = {
				["scale"] = 100,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -51,
				["x"] = 0,
				["drop"] = true,
				["height"] = 12,
				["anchor"] = "BottomRight",
				["enable"] = true,
			},
			["cast"] = {
				["prevOrient"] = "VERTICAL",
				["multi"] = true,
				["textheight"] = 12,
				["backdropOpacity"] = 40,
				["arcMid"] = 0,
				["anchor"] = "BottomRight",
				["showBG"] = true,
				["orient"] = "VERTICAL",
				["textAnchor"] = "Left",
				["frameLayer"] = 2,
				["yTextOffset"] = 0,
				["xTextOffset"] = 24,
				["arc"] = 0,
				["height"] = 128,
				["rotate"] = true,
				["maxTextWidth"] = 199,
				["enable"] = true,
				["sparkY"] = -2,
				["Sparkarc"] = 72,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\GlowArc2.tga",
				["frameLevel"] = 2,
				["alpha"] = 100,
				["x"] = -62,
				["frameStrata"] = 2,
				["width"] = 67,
				["y"] = 42,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["scale"] = 100,
				["textY"] = 37,
				["textureName"] = "GlowArc2",
				["textX"] = 30,
				["anchorText"] = "TopRight",
			},
			["altPower"] = {
				["maxTextWidth"] = 1000,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["textVert"] = 2,
				["backdropOpacity"] = 50,
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textHori"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["mouseover"] = "value",
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
			},
			["Class"] = {
				["textY"] = 0,
				["prevOrient"] = "HORIZONTAL",
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "value",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["orient"] = "HORIZONTAL",
				["textVert"] = 2,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -41,
				["x"] = -106,
				["mouseover"] = "value",
				["height"] = 12,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textX"] = 0,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["enable"] = true,
				["alpha"] = 100,
				["y"] = 11,
				["x"] = 43,
				["mouseOverTooltip"] = true,
				["anchor"] = "BottomLeft",
				["frameStrata"] = 2,
				["scale"] = 62,
			},
			["scale"] = 1,
			["background"] = {
				["scale"] = 100,
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["b"] = 100,
					["g"] = 100,
					["r"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "Right",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 100,
				["y"] = 0,
				["x"] = -1,
				["height"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["color"] = {
					["a"] = 0.5,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["enable"] = false,
			},
			["power"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 34,
				["anchor"] = "BottomRight",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 153,
				["anchorText"] = "Left",
				["percent"] = true,
				["maxTextWidth"] = 98,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "GlowArc2",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\GlowArc2.tga",
				["LifeTime"] = 0,
				["textHori"] = 2,
				["rotate"] = true,
				["leftOffset"] = 0,
				["scale"] = 100,
				["alpha"] = 100,
				["textY"] = 99,
				["frameStrata"] = 2,
				["width"] = 59,
				["textX"] = 83.4364624023438,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["x"] = -51,
				["y"] = 29,
				["textVert"] = 2,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["height"] = 10,
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = 58,
				["x"] = -8,
				["justifyH"] = 3,
				["height"] = 12,
				["frameStrata"] = 2,
				["anchor"] = "Bottom",
				["enable"] = true,
			},
			["Health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["frameStrata"] = 2,
				["width"] = 51,
				["orient"] = "HORIZONTAL",
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["textY"] = 0,
				["textVert"] = 2,
				["alpha"] = 100,
				["topOffset"] = 0,
			},
			["frameLayer"] = 4,
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 99,
				["y"] = -15,
				["x"] = -4,
				["justifyH"] = 3,
				["anchor"] = "Left",
				["frameStrata"] = 2,
				["scale"] = 100,
				["height"] = 40,
			},
			["showInOverrideUI"] = false,
			["frameStrata"] = 4,
			["width"] = 105,
			["alpha"] = 0.8,
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["enable"] = true,
				["space"] = 0,
				["isLeftToRight"] = false,
				["scale"] = 89,
				["yArc"] = 0,
				["xFlex"] = -10,
				["frameLayer"] = 1,
				["spacing"] = -2,
				["anchor"] = "BottomLeft",
				["angle"] = 111,
				["rings"] = 1,
				["IsLeftToRight"] = false,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 1,
				["compress"] = 58,
				["width"] = 96,
				["frameStrata"] = 2,
				["alpha"] = 100,
				["xArc"] = 66,
				["y"] = 29,
				["isTopToBottom"] = true,
				["style"] = "BAR",
				["reverse"] = true,
				["height"] = 200,
				["x"] = -5,
				["spin"] = 0,
				["IsTopToBottom"] = true,
			},
			["health"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 40,
				["arcMid"] = 0,
				["anchor"] = "BottomRight",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["x"] = -47,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Right",
				["percent"] = true,
				["textY"] = 100,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "GlowArc2",
				["LifeTime"] = 0,
				["justifyH"] = "CENTER",
				["drop"] = true,
				["xTextOffset"] = 0,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\GlowArc2.tga",
				["rotate"] = true,
				["height"] = 165,
				["textVert"] = 2,
				["textX"] = -4,
				["leftOffset"] = 0,
				["maxTextWidth"] = 98,
				["frameStrata"] = 2,
				["alpha"] = 100,
				["width"] = 76,
				["classColor"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["enable"] = true,
				["rigtOffset"] = 1,
				["bottomOffset"] = 100,
				["y"] = 22,
				["topOffset"] = 55,
			},
			["model"] = {
				["zoom"] = 0,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 120,
				["justifyV"] = "CENTER",
				["frameStrata"] = 2,
				["width"] = 110,
				["y"] = 29,
				["x"] = 8,
				["justifyH"] = "CENTER",
				["clickThru"] = true,
				["height"] = 134,
				["enable"] = true,
				["anchor"] = "BottomLeft",
				["rotation"] = 0,
			},
			["padH"] = 1,
			["buffs"] = {
				["enable"] = true,
				["rows"] = 9,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["showBG"] = false,
				["columns"] = 3,
				["frameLayer"] = 1,
				["alpha"] = 100,
				["y"] = -27,
				["x"] = -78,
				["frameStrata"] = 2,
				["reverse"] = false,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["isLeftToRight"] = false,
				["scale"] = 77,
				["isTopToBottom"] = false,
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 2,
				["width"] = 25,
				["y"] = 47,
				["x"] = 36,
				["justifyH"] = 1,
				["height"] = 26,
				["frameStrata"] = 2,
				["enable"] = true,
				["anchor"] = "Left",
			},
			["padW"] = 1,
		},
		["focus"] = {
			["overlay"] = {
				["y"] = 0,
				["x"] = 0,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["enable"] = false,
			},
			["debuffs"] = {
				["scale"] = 76,
				["frameStrata"] = 2,
				["columns"] = 6,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["rows"] = 3,
				["isLeftToRight"] = true,
				["x"] = 42,
				["y"] = 69,
				["isTopToBottom"] = true,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Bottom",
				["enable"] = false,
				["showBG"] = false,
				["alpha"] = 100,
			},
			["resource"] = {
				["enable"] = true,
				["columns"] = 1,
				["compress"] = 0,
				["scale"] = 64,
				["height"] = 50,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = 12,
				["style"] = "Bar",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["angle"] = 0,
				["showBG"] = false,
				["isTopToBottom"] = false,
			},
			["scale"] = 0.81,
			["Class"] = {
				["textY"] = 0,
				["prevOrient"] = "HORIZONTAL",
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "BottomRight",
				["format"] = "value",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["orient"] = "HORIZONTAL",
				["textVert"] = 2,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = 41,
				["x"] = -106,
				["mouseover"] = "value",
				["height"] = 12,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textX"] = 0,
			},
			["cast"] = {
				["prevOrient"] = "HORIZONTAL",
				["multi"] = true,
				["textheight"] = 166,
				["backdropOpacity"] = 100,
				["arcMid"] = 5,
				["anchor"] = "Center",
				["showBG"] = true,
				["orient"] = "HORIZONTAL",
				["textAnchor"] = "Center",
				["frameLayer"] = 4,
				["y"] = 209,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 26.3898334503174,
				["anchorText"] = "Center",
				["textY"] = 4,
				["scale"] = 100,
				["sparkConfig"] = false,
				["sparkY"] = 0,
				["Sparkarc"] = 0,
				["drop"] = false,
				["arcEnd"] = -135.303436279297,
				["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
				["reverseArc"] = false,
				["frameLevel"] = 2,
				["rotate"] = false,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 290.593536376953,
				["enable"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["maxTextWidth"] = 300,
				["textureName"] = "Aluminium",
				["yTextOffset"] = 0,
				["textX"] = 0,
				["x"] = 0,
			},
			["altPower"] = {
				["maxTextWidth"] = 1000,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["textVert"] = 2,
				["backdropOpacity"] = 50,
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textHori"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["mouseover"] = "value",
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["enable"] = true,
				["alpha"] = 100,
				["y"] = -30,
				["x"] = 0,
				["mouseOverTooltip"] = true,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["scale"] = 80,
			},
			["background"] = {
				["scale"] = 100,
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["b"] = 100,
					["g"] = 100,
					["r"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "Center",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 100,
				["y"] = 0,
				["x"] = 0,
				["height"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["color"] = {
					["a"] = 0.5,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["enable"] = false,
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 3,
				["width"] = 84.9306716918945,
				["y"] = -5,
				["x"] = 23,
				["justifyH"] = 3,
				["height"] = 12,
				["frameStrata"] = 2,
				["anchor"] = "Bottom",
				["enable"] = true,
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 115,
				["justifyV"] = 2,
				["width"] = 25,
				["y"] = -5,
				["x"] = -23,
				["justifyH"] = 2,
				["height"] = 26,
				["frameStrata"] = 2,
				["enable"] = true,
				["anchor"] = "Bottom",
			},
			["power"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 100,
				["anchor"] = "BottomRight",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = 0,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["textHori"] = 3,
				["anchorText"] = "BottomRight",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 96,
				["justifyV"] = "CENTER",
				["textureName"] = "Bar",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["LifeTime"] = 0,
				["arcEnd"] = 4,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\Bar.tga",
				["yTextOffset"] = 0,
				["x"] = 127,
				["reverseArc"] = false,
				["leftOffset"] = 0,
				["textVert"] = 2,
				["textY"] = -6,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 143,
				["enable"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["rotate"] = true,
				["height"] = 218,
				["textX"] = -139,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["fadeAlpha"] = 0.65,
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["enable"] = true,
				["space"] = 0,
				["isLeftToRight"] = true,
				["scale"] = 102,
				["yArc"] = 0,
				["xFlex"] = 0,
				["frameLayer"] = 1,
				["spacing"] = 0,
				["anchor"] = "Bottom",
				["angle"] = 304,
				["rings"] = 1,
				["IsLeftToRight"] = false,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 10,
				["compress"] = 64,
				["width"] = 76,
				["frameStrata"] = 2,
				["alpha"] = 100,
				["xArc"] = 0,
				["y"] = 0,
				["isTopToBottom"] = true,
				["style"] = "ROUND",
				["reverse"] = true,
				["height"] = 196,
				["x"] = 0,
				["spin"] = 0,
				["IsTopToBottom"] = true,
			},
			["width"] = 322,
			["health"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 100,
				["arcMid"] = 0,
				["anchor"] = "BottomLeft",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["x"] = -127,
				["arc"] = 0,
				["textHori"] = 3,
				["anchorText"] = "BottomLeft",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 96,
				["justifyV"] = "CENTER",
				["textureName"] = "Bar2",
				["LifeTime"] = 0,
				["rotate"] = true,
				["justifyH"] = "CENTER",
				["drop"] = true,
				["height"] = 218,
				["arcEnd"] = 37.0818939208984,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\Bar2.tga",
				["xTextOffset"] = 0,
				["textVert"] = 1,
				["reverseArc"] = false,
				["textX"] = 125,
				["leftOffset"] = 0,
				["textY"] = -6,
				["frameStrata"] = 2,
				["alpha"] = 100,
				["width"] = 142.119247436523,
				["classColor"] = false,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["enable"] = true,
				["rigtOffset"] = 1,
				["bottomOffset"] = 100,
				["y"] = 0,
				["topOffset"] = 0,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 2,
				["width"] = 153,
				["y"] = -73,
				["x"] = -2,
				["justifyH"] = 2,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["scale"] = 126,
				["height"] = 24,
			},
			["Health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["frameStrata"] = 2,
				["width"] = 51,
				["orient"] = "HORIZONTAL",
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["textY"] = 0,
				["textVert"] = 2,
				["alpha"] = 100,
				["topOffset"] = 0,
			},
			["model"] = {
				["zoom"] = 98,
				["frameLevel"] = 1,
				["frameLayer"] = 3,
				["scale"] = 51,
				["justifyV"] = "CENTER",
				["frameStrata"] = 2,
				["width"] = 307,
				["y"] = 45,
				["x"] = -110,
				["justifyH"] = "CENTER",
				["clickThru"] = true,
				["height"] = 207,
				["enable"] = false,
				["anchor"] = "TopLeft",
				["rotation"] = 0,
			},
			["height"] = 10,
			["buffs"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["frameStrata"] = 2,
				["columns"] = 7,
				["frameLayer"] = 1,
				["scale"] = 64,
				["rows"] = 2,
				["isLeftToRight"] = true,
				["isTopToBottom"] = false,
				["y"] = 35,
				["x"] = 31,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "TopLeft",
				["enable"] = false,
				["showBG"] = true,
				["alpha"] = 100,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "Bottom",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -63,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 17.3252716064453,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textX"] = 0,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 115.20288848877,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["x"] = 0,
				["textHori"] = 2,
				["textVert"] = 2,
				["topOffset"] = 0,
			},
			["class"] = {
				["textY"] = -8,
				["enable"] = true,
				["sparkConfig"] = false,
				["textureName"] = "Bar",
				["drop"] = false,
				["anchor"] = "Center",
				["arcEnd"] = 47,
				["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
				["textX"] = 0,
				["alpha"] = 100,
				["width"] = 207,
				["y"] = -5,
				["x"] = 0,
				["height"] = 64,
				["sparkSize"] = 39,
				["scale"] = 100,
				["arcMid"] = -9,
			},
		},
		["playerpet"] = {
			["overlay"] = {
				["y"] = 0,
				["x"] = 0,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["enable"] = false,
			},
			["debuffs"] = {
				["scale"] = 76,
				["frameStrata"] = 2,
				["columns"] = 6,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["rows"] = 3,
				["isLeftToRight"] = true,
				["x"] = 42,
				["y"] = 69,
				["isTopToBottom"] = true,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Bottom",
				["enable"] = false,
				["showBG"] = false,
				["alpha"] = 100,
			},
			["resource"] = {
				["rotateIcons"] = 46,
				["enable"] = true,
				["spacing"] = 6,
				["anchor"] = "Bottom",
				["angle"] = 122,
				["showBG"] = false,
				["columns"] = 5,
				["compress"] = 30,
				["alpha"] = 100,
				["width"] = 149,
				["y"] = -26,
				["isTopToBottom"] = true,
				["style"] = "Bar",
				["height"] = 175,
				["scale"] = 100,
				["x"] = 0,
				["isLeftToRight"] = true,
			},
			["altpower"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "BottomRight",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["x"] = 66,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "BottomRight",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Bar",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["LifeTime"] = 0,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\Bar.tga",
				["rotate"] = true,
				["textVert"] = 2,
				["reverseArc"] = false,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["y"] = 0,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 80,
				["textX"] = -88.7390899658203,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["textY"] = 5,
				["enable"] = true,
				["height"] = 191,
				["xTextOffset"] = 0,
				["topOffset"] = 0,
			},
			["class"] = {
				["textY"] = -8,
				["scale"] = 100,
				["sparkConfig"] = false,
				["textureName"] = "Bar",
				["drop"] = false,
				["anchor"] = "Center",
				["arcEnd"] = 47,
				["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
				["textX"] = 0,
				["alpha"] = 100,
				["width"] = 207,
				["y"] = -5,
				["x"] = 0,
				["height"] = 64,
				["arcMid"] = -9,
				["enable"] = true,
				["sparkSize"] = 39,
			},
			["cast"] = {
				["prevOrient"] = "HORIZONTAL",
				["multi"] = true,
				["textheight"] = 166,
				["backdropOpacity"] = 100,
				["arcMid"] = 5,
				["anchor"] = "Center",
				["showBG"] = true,
				["orient"] = "HORIZONTAL",
				["textAnchor"] = "Center",
				["frameLayer"] = 4,
				["yTextOffset"] = 0,
				["xTextOffset"] = 0,
				["arc"] = -86,
				["height"] = 105,
				["rotate"] = false,
				["maxTextWidth"] = 300,
				["enable"] = true,
				["sparkConfig"] = false,
				["sparkY"] = 1,
				["Sparkarc"] = -69,
				["drop"] = false,
				["arcEnd"] = -135.303436279297,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\GlowArc2.tga",
				["reverseArc"] = false,
				["frameLevel"] = 2,
				["y"] = 217,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 205,
				["x"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["textX"] = 0,
				["anchorText"] = "Center",
				["textY"] = 4,
				["scale"] = 100,
				["textureName"] = "GlowArc2",
			},
			["fadeAlpha"] = 0.65,
			["altPower"] = {
				["maxTextWidth"] = 1000,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["textVert"] = 2,
				["backdropOpacity"] = 50,
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textHori"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["mouseover"] = "value",
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
			},
			["clickThrough"] = true,
			["Class"] = {
				["textY"] = 0,
				["prevOrient"] = "HORIZONTAL",
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "BottomRight",
				["format"] = "value",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["orient"] = "HORIZONTAL",
				["textVert"] = 2,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = 41,
				["x"] = -106,
				["mouseover"] = "value",
				["height"] = 12,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textX"] = 0,
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 2,
				["width"] = 25,
				["y"] = 0,
				["x"] = 0,
				["justifyH"] = 2,
				["height"] = 26,
				["frameStrata"] = 2,
				["enable"] = true,
				["anchor"] = "Right",
			},
			["scale"] = 0.84,
			["height"] = 10,
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 3,
				["width"] = 35,
				["y"] = 0,
				["x"] = 0,
				["justifyH"] = 3,
				["height"] = 12,
				["frameStrata"] = 2,
				["anchor"] = "Bottom",
				["enable"] = true,
			},
			["Health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["frameStrata"] = 2,
				["width"] = 51,
				["orient"] = "HORIZONTAL",
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["textY"] = 0,
				["textVert"] = 2,
				["alpha"] = 100,
				["topOffset"] = 0,
			},
			["power"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 100,
				["anchor"] = "BottomRight",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = 0,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["textHori"] = 3,
				["anchorText"] = "BottomRight",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 96,
				["justifyV"] = "CENTER",
				["textureName"] = "Bar",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["LifeTime"] = 0,
				["arcEnd"] = 4,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\Bar.tga",
				["yTextOffset"] = 0,
				["textVert"] = 2,
				["reverseArc"] = false,
				["leftOffset"] = 0,
				["height"] = 199,
				["textY"] = -6,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 127,
				["enable"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["rotate"] = true,
				["x"] = 113,
				["textX"] = -139,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["health"] = {
				["prevOrient"] = "VERTICAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 100,
				["arcMid"] = 0,
				["anchor"] = "BottomLeft",
				["format"] = "percent",
				["orient"] = "VERTICAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["x"] = -113,
				["arc"] = 0,
				["textHori"] = 3,
				["anchorText"] = "BottomLeft",
				["percent"] = true,
				["textY"] = -6,
				["scale"] = 96,
				["justifyV"] = "CENTER",
				["textureName"] = "Bar2",
				["LifeTime"] = 0,
				["rotate"] = true,
				["justifyH"] = "CENTER",
				["drop"] = true,
				["height"] = 199,
				["arcEnd"] = 37.0818939208984,
				["texturePath"] = "Interface\\AddOns\\Dominos_Units\\textures\\Bar2.tga",
				["xTextOffset"] = 0,
				["textVert"] = 1,
				["reverseArc"] = false,
				["textX"] = 125,
				["leftOffset"] = 0,
				["maxTextWidth"] = 300,
				["frameStrata"] = 2,
				["alpha"] = 100,
				["width"] = 127,
				["classColor"] = false,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = false,
				["enable"] = true,
				["rigtOffset"] = 1,
				["bottomOffset"] = 100,
				["y"] = 0,
				["topOffset"] = 0,
			},
			["showInOverrideUI"] = false,
			["alpha"] = 0.9,
			["width"] = 89,
			["icons"] = {
				["xShift"] = 0,
				["spin"] = 0,
				["rev"] = false,
				["enable"] = true,
				["space"] = -4,
				["alpha"] = 100,
				["scale"] = 95,
				["yArc"] = 6,
				["offset"] = 0,
				["compress"] = 67,
				["spacing"] = -2,
				["anchor"] = "Left",
				["angle"] = 304,
				["rings"] = 1,
				["IsLeftToRight"] = false,
				["xFlex"] = 0,
				["yFlex"] = 8,
				["columns"] = 1,
				["frameLayer"] = 1,
				["width"] = 27,
				["frameStrata"] = 2,
				["isLeftToRight"] = true,
				["xArc"] = 27,
				["y"] = 93,
				["IsTopToBottom"] = true,
				["style"] = "BAR",
				["reverse"] = false,
				["height"] = 30,
				["isTopToBottom"] = true,
				["yShift"] = 0,
				["x"] = -12,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["enable"] = false,
				["alpha"] = 100,
				["y"] = 0,
				["x"] = -36,
				["mouseOverTooltip"] = true,
				["anchor"] = "Left",
				["frameStrata"] = 2,
				["scale"] = 80,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 2,
				["width"] = 98,
				["y"] = 0,
				["x"] = 16,
				["justifyH"] = 1,
				["anchor"] = "Left",
				["frameStrata"] = 2,
				["scale"] = 100,
				["height"] = 26,
			},
			["model"] = {
				["zoom"] = 98,
				["frameLevel"] = 1,
				["frameLayer"] = 3,
				["scale"] = 51,
				["justifyV"] = "CENTER",
				["frameStrata"] = 2,
				["width"] = 307,
				["y"] = 45,
				["x"] = -110,
				["justifyH"] = "CENTER",
				["clickThru"] = true,
				["height"] = 207,
				["enable"] = false,
				["anchor"] = "TopLeft",
				["rotation"] = 0,
			},
			["padH"] = 28,
			["buffs"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["rows"] = 2,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "TopLeft",
				["showBG"] = true,
				["columns"] = 7,
				["frameLayer"] = 1,
				["alpha"] = 100,
				["y"] = 35,
				["isTopToBottom"] = false,
				["frameStrata"] = 2,
				["reverse"] = false,
				["enable"] = false,
				["isLeftToRight"] = true,
				["scale"] = 64,
				["x"] = 31,
			},
			["background"] = {
				["scale"] = 100,
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["b"] = 100,
					["g"] = 100,
					["r"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "Center",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 100,
				["y"] = 0,
				["x"] = 0,
				["height"] = 100,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["color"] = {
					["a"] = 0.5,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["enable"] = false,
			},
			["padW"] = 28,
		},
		["boss3"] = {
			["overlay"] = {
				["y"] = 0,
				["x"] = 0,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["enable"] = false,
			},
			["debuffs"] = {
				["frameStrata"] = 2,
				["alpha"] = 100,
				["columns"] = 7,
				["frameLayer"] = 1,
				["scale"] = 77,
				["rows"] = 2,
				["isLeftToRight"] = true,
				["x"] = 354,
				["y"] = 47,
				["isTopToBottom"] = false,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["enable"] = false,
				["showBG"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
			},
			["resource"] = {
				["enable"] = true,
				["columns"] = 1,
				["compress"] = 0,
				["scale"] = 64,
				["height"] = 50,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = 12,
				["style"] = "Bar",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["angle"] = 0,
				["showBG"] = false,
				["isTopToBottom"] = false,
			},
			["scale"] = 1,
			["class"] = {
				["scale"] = 100,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -51,
				["x"] = 0,
				["drop"] = true,
				["height"] = 12,
				["anchor"] = "BottomRight",
				["enable"] = true,
			},
			["padW"] = 0,
			["altPower"] = {
				["maxTextWidth"] = 1000,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["textVert"] = 2,
				["backdropOpacity"] = 50,
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textHori"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["mouseover"] = "value",
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["scale"] = 86,
				["alpha"] = 100,
				["y"] = 0,
				["x"] = -2,
				["mouseOverTooltip"] = true,
				["anchor"] = "Left",
				["frameStrata"] = 2,
				["enable"] = true,
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 2,
				["width"] = 25,
				["y"] = 0,
				["x"] = 0,
				["justifyH"] = 2,
				["height"] = 26,
				["frameStrata"] = 2,
				["anchor"] = "Right",
				["enable"] = true,
			},
			["background"] = {
				["enable"] = true,
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["r"] = 100,
					["g"] = 100,
					["b"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "Right",
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 91,
				["y"] = 0,
				["x"] = 0,
				["height"] = 51,
				["inset"] = 0,
				["color"] = {
					["a"] = 0.5,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["scale"] = 100,
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = 12,
				["x"] = 0,
				["justifyH"] = 3,
				["height"] = 12,
				["frameStrata"] = 2,
				["enable"] = true,
				["anchor"] = "top",
			},
			["cast"] = {
				["prevOrient"] = "HORIZONTAL",
				["multi"] = true,
				["textheight"] = 12,
				["backdropOpacity"] = 50,
				["arcMid"] = 0,
				["anchor"] = "Right",
				["showBG"] = false,
				["orient"] = "HORIZONTAL",
				["textAnchor"] = "Center",
				["frameLayer"] = 4,
				["yTextOffset"] = 0,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 22,
				["rotate"] = 0,
				["textY"] = 0,
				["enable"] = true,
				["textureName"] = "Blizzard",
				["Sparkarc"] = 0,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["frameLevel"] = 2,
				["alpha"] = 100,
				["x"] = -1,
				["frameStrata"] = 2,
				["width"] = 122,
				["y"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["maxTextWidth"] = 98,
				["sparkY"] = 0,
				["textX"] = 0,
				["anchorText"] = "Center",
			},
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 0.5,
				["anchor"] = "BottomRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["x"] = 0,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["enable"] = true,
				["maxTextWidth"] = 98,
				["alpha"] = 100,
				["width"] = 124,
				["textVert"] = 2,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["xTextOffset"] = 0,
				["y"] = -1,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 2,
				["width"] = 98,
				["y"] = 0,
				["x"] = 51,
				["justifyH"] = 1,
				["anchor"] = "Left",
				["frameStrata"] = 2,
				["height"] = 26,
				["scale"] = 100,
			},
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["spin"] = 0,
				["scale"] = 78,
				["space"] = 0,
				["isLeftToRight"] = true,
				["enable"] = true,
				["IsLeftToRight"] = false,
				["xFlex"] = 0,
				["frameLayer"] = 4,
				["spacing"] = 0,
				["anchor"] = "Left",
				["angle"] = 46,
				["isTopToBottom"] = false,
				["yArc"] = 0,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["compress"] = 0,
				["width"] = 55,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["xArc"] = 0,
				["y"] = 0,
				["x"] = 0,
				["style"] = "SQUARE",
				["reverse"] = true,
				["height"] = 55,
				["IsTopToBottom"] = true,
				["yShift"] = 0,
				["rings"] = 1,
			},
			["width"] = 173,
			["padH"] = 0,
			["Health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["frameStrata"] = 2,
				["width"] = 51,
				["orient"] = "HORIZONTAL",
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["textY"] = 0,
				["textVert"] = 2,
				["alpha"] = 100,
				["topOffset"] = 0,
			},
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 1,
				["backdropOpacity"] = 0.5,
				["arcMid"] = 0,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["bottomOffset"] = 1,
				["frameLayer"] = 1,
				["mouseover"] = "current",
				["yTextOffset"] = 0,
				["x"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["y"] = 0,
				["xTextOffset"] = 0,
				["textX"] = 0,
				["textVert"] = 2,
				["leftOffset"] = 0,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 124,
				["enable"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["maxTextWidth"] = 98,
				["rigtOffset"] = 1,
				["orient"] = "HORIZONTAL",
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["model"] = {
				["clickThru"] = true,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 1,
				["justifyV"] = "CENTER",
				["frameStrata"] = 2,
				["width"] = 133,
				["y"] = -45,
				["x"] = -110,
				["justifyH"] = "CENTER",
				["rotation"] = 0,
				["anchor"] = "BottomLeft",
				["height"] = 197,
				["enable"] = false,
				["zoom"] = 0,
			},
			["height"] = 47,
			["buffs"] = {
				["frameStrata"] = 2,
				["alpha"] = 100,
				["columns"] = 7,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["rows"] = 2,
				["isLeftToRight"] = true,
				["isTopToBottom"] = false,
				["y"] = 48,
				["x"] = 2,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["enable"] = false,
				["showBG"] = false,
				["scale"] = 77,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -52,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textX"] = 0,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 51,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["x"] = -106,
				["textHori"] = 2,
				["textVert"] = 2,
				["topOffset"] = 0,
			},
			["Class"] = {
				["textY"] = 0,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "value",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["orient"] = "HORIZONTAL",
				["textX"] = 0,
				["scale"] = 100,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -41,
				["x"] = -106,
				["mouseover"] = "value",
				["height"] = 12,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textVert"] = 2,
			},
		},
		["boss2"] = {
			["overlay"] = {
				["y"] = 0,
				["x"] = 0,
				["frameLayer"] = 1,
				["anchor"] = "Center",
				["frameStrata"] = 2,
				["enable"] = false,
			},
			["debuffs"] = {
				["frameStrata"] = 2,
				["alpha"] = 100,
				["columns"] = 7,
				["frameLayer"] = 1,
				["scale"] = 77,
				["rows"] = 2,
				["isLeftToRight"] = true,
				["x"] = -354,
				["y"] = 47,
				["isTopToBottom"] = false,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["enable"] = false,
				["showBG"] = false,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
			},
			["resource"] = {
				["enable"] = true,
				["columns"] = 1,
				["compress"] = 0,
				["scale"] = 64,
				["height"] = 50,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["x"] = 12,
				["style"] = "Bar",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["angle"] = 0,
				["showBG"] = false,
				["isTopToBottom"] = false,
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -52,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["yTextOffset"] = 0,
				["textX"] = 0,
				["leftOffset"] = 0,
				["bottomOffset"] = 100,
				["enable"] = true,
				["alpha"] = 100,
				["width"] = 51,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["x"] = -106,
				["textHori"] = 2,
				["textVert"] = 2,
				["topOffset"] = 0,
			},
			["class"] = {
				["scale"] = 100,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -51,
				["x"] = 0,
				["drop"] = true,
				["height"] = 12,
				["anchor"] = "BottomLeft",
				["enable"] = true,
			},
			["padW"] = 0,
			["altPower"] = {
				["maxTextWidth"] = 1000,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["textVert"] = 2,
				["backdropOpacity"] = 50,
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textHori"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["mouseover"] = "value",
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["scale"] = 86,
				["alpha"] = 100,
				["y"] = 0,
				["x"] = 2,
				["mouseOverTooltip"] = true,
				["anchor"] = "Right",
				["frameStrata"] = 2,
				["enable"] = true,
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 2,
				["width"] = 25,
				["y"] = 0,
				["x"] = 0,
				["justifyH"] = 2,
				["height"] = 26,
				["frameStrata"] = 2,
				["anchor"] = "Left",
				["enable"] = true,
			},
			["background"] = {
				["enable"] = true,
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["r"] = 100,
					["g"] = 100,
					["b"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "Left",
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 91,
				["y"] = 0,
				["x"] = 0,
				["height"] = 51,
				["inset"] = 0,
				["color"] = {
					["a"] = 0.5,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["scale"] = 100,
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = 12,
				["x"] = 0,
				["justifyH"] = 1,
				["height"] = 12,
				["frameStrata"] = 2,
				["enable"] = true,
				["anchor"] = "top",
			},
			["cast"] = {
				["prevOrient"] = "HORIZONTAL",
				["multi"] = true,
				["textheight"] = 12,
				["backdropOpacity"] = 50,
				["arcMid"] = 0,
				["anchor"] = "Left",
				["showBG"] = false,
				["orient"] = "HORIZONTAL",
				["textAnchor"] = "Center",
				["frameLayer"] = 4,
				["yTextOffset"] = 0,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 22,
				["rotate"] = 0,
				["textY"] = 0,
				["enable"] = true,
				["textureName"] = "Blizzard",
				["Sparkarc"] = 0,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["frameLevel"] = 2,
				["alpha"] = 100,
				["x"] = 1,
				["frameStrata"] = 2,
				["width"] = 122,
				["y"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["maxTextWidth"] = 98,
				["sparkY"] = 0,
				["textX"] = 0,
				["anchorText"] = "Center",
			},
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 0.5,
				["anchor"] = "BottomLeft",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["yTextOffset"] = 0,
				["x"] = 0,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["enable"] = true,
				["maxTextWidth"] = 98,
				["alpha"] = 100,
				["width"] = 124,
				["textVert"] = 2,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["frameStrata"] = 2,
				["xTextOffset"] = 0,
				["y"] = -1,
				["bottomOffset"] = 100,
				["topOffset"] = 0,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 2,
				["width"] = 98,
				["y"] = 0,
				["x"] = -51,
				["justifyH"] = 3,
				["anchor"] = "Right",
				["frameStrata"] = 2,
				["height"] = 26,
				["scale"] = 100,
			},
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["spin"] = 0,
				["scale"] = 78,
				["space"] = 0,
				["isLeftToRight"] = false,
				["enable"] = true,
				["IsLeftToRight"] = false,
				["xFlex"] = 0,
				["frameLayer"] = 4,
				["spacing"] = 0,
				["anchor"] = "Right",
				["angle"] = 46,
				["isTopToBottom"] = false,
				["yArc"] = 0,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["compress"] = 0,
				["width"] = 55,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["xArc"] = 0,
				["y"] = 0,
				["x"] = 0,
				["style"] = "SQUARE",
				["reverse"] = true,
				["height"] = 55,
				["IsTopToBottom"] = true,
				["yShift"] = 0,
				["rings"] = 1,
			},
			["width"] = 173,
			["padH"] = 0,
			["Health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["leftOffset"] = 0,
				["textX"] = 0,
				["height"] = 12,
				["frameStrata"] = 2,
				["width"] = 51,
				["orient"] = "HORIZONTAL",
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["scale"] = 100,
				["textY"] = 0,
				["textVert"] = 2,
				["alpha"] = 100,
				["topOffset"] = 0,
			},
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 1,
				["backdropOpacity"] = 0.5,
				["arcMid"] = 0,
				["anchor"] = "TopLeft",
				["format"] = "percent",
				["bottomOffset"] = 1,
				["frameLayer"] = 1,
				["mouseover"] = "current",
				["yTextOffset"] = 0,
				["x"] = 0,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["arcEnd"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["LifeTime"] = 0,
				["y"] = 0,
				["xTextOffset"] = 0,
				["textX"] = 0,
				["textVert"] = 2,
				["leftOffset"] = 0,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 124,
				["enable"] = true,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["maxTextWidth"] = 98,
				["rigtOffset"] = 1,
				["orient"] = "HORIZONTAL",
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["model"] = {
				["clickThru"] = true,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 1,
				["justifyV"] = "CENTER",
				["frameStrata"] = 2,
				["width"] = 133,
				["y"] = -45,
				["x"] = 110,
				["justifyH"] = "CENTER",
				["rotation"] = 0,
				["anchor"] = "BottomRight",
				["height"] = 197,
				["enable"] = false,
				["zoom"] = 0,
			},
			["height"] = 47,
			["buffs"] = {
				["frameStrata"] = 2,
				["alpha"] = 100,
				["columns"] = 7,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["r"] = 0,
					["g"] = 0,
					["b"] = 0,
				},
				["rows"] = 2,
				["isLeftToRight"] = true,
				["isTopToBottom"] = false,
				["y"] = 48,
				["x"] = -2,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["enable"] = false,
				["showBG"] = false,
				["scale"] = 77,
			},
			["scale"] = 1,
			["Class"] = {
				["textY"] = 0,
				["prevOrient"] = "HORIZONTAL",
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "TopLeft",
				["format"] = "value",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["orient"] = "HORIZONTAL",
				["textX"] = 0,
				["scale"] = 100,
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -41,
				["x"] = 106,
				["mouseover"] = "value",
				["height"] = 12,
				["textHori"] = 2,
				["anchorText"] = "Center",
				["percent"] = true,
				["textVert"] = 2,
			},
		},
		["playerpettarget"] = {
			["overlay"] = {
				["enable"] = true,
				["x"] = 0,
				["y"] = 0,
				["anchor"] = "Center",
			},
			["debuffs"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["isLeftToRight"] = true,
				["columns"] = 6,
				["frameLayer"] = 1,
				["scale"] = 76,
				["rows"] = 3,
				["alpha"] = 100,
				["enable"] = true,
				["y"] = -73,
				["isTopToBottom"] = true,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Top",
				["x"] = 0,
				["showBG"] = false,
				["frameStrata"] = 2,
			},
			["altpower"] = {
				["enable"] = true,
				["textY"] = 0,
				["backdropOpacity"] = 50,
				["prevOrient"] = "HORIZONTAL",
				["scale"] = 100,
				["xTextOffset"] = 0,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["textHori"] = 2,
				["textVert"] = 2,
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["frameStrata"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["frameLayer"] = 1,
				["yTextOffset"] = 0,
				["mouseover"] = "value",
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
			},
			["cast"] = {
				["maxTextWidth"] = 98,
				["enable"] = true,
				["multi"] = true,
				["sparkY"] = 0,
				["textureName"] = "Blizzard",
				["Sparkarc"] = 0,
				["backdropOpacity"] = 50,
				["frameLevel"] = 2,
				["anchor"] = "Left",
				["showBG"] = false,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["x"] = 7,
				["orient"] = "HORIZONTAL",
				["alpha"] = 100,
				["textX"] = 0,
				["frameLayer"] = 4,
				["yTextOffset"] = 0,
				["xTextOffset"] = 0,
				["frameStrata"] = 2,
				["width"] = 117,
				["y"] = 17,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 16,
				["anchorText"] = "Center",
				["textY"] = 0,
				["scale"] = 100,
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 1,
				["scale"] = 95,
				["alpha"] = 100,
				["y"] = -12,
				["x"] = -42,
				["mouseOverTooltip"] = true,
				["anchor"] = "TopRight",
				["enable"] = true,
				["frameStrata"] = 2,
			},
			["level"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 25,
				["y"] = -16,
				["x"] = 63,
				["justifyH"] = 2,
				["height"] = 12,
				["enable"] = true,
				["anchor"] = "Center",
				["frameStrata"] = 2,
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = 12,
				["x"] = 0,
				["justifyH"] = 3,
				["height"] = 12,
				["anchor"] = "top",
				["enable"] = true,
				["frameStrata"] = 2,
			},
			["power"] = {
				["enable"] = true,
				["textY"] = 0,
				["backdropOpacity"] = 50,
				["prevOrient"] = "HORIZONTAL",
				["scale"] = 100,
				["xTextOffset"] = 0,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["textHori"] = 2,
				["textVert"] = 2,
				["justifyH"] = "CENTER",
				["drop"] = true,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["frameStrata"] = 2,
				["orient"] = "HORIZONTAL",
				["x"] = -106,
				["textX"] = 0,
				["frameLayer"] = 1,
				["yTextOffset"] = 0,
				["mouseover"] = "value",
				["alpha"] = 100,
				["width"] = 51,
				["y"] = -52,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
			},
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["scale"] = 130,
				["spacing"] = 0,
				["space"] = 0,
				["anchor"] = "Right",
				["xArc"] = 0,
				["spin"] = 0,
				["offset"] = 0,
				["yFlex"] = 0,
				["columns"] = 8,
				["frameLayer"] = 2,
				["alpha"] = 100,
				["IsTopToBottom"] = true,
				["frameStrata"] = 2,
				["width"] = 1,
				["y"] = 2,
				["rings"] = 1,
				["yArc"] = 0,
				["x"] = -45,
				["height"] = 1,
				["xFlex"] = 0,
				["enable"] = true,
				["IsLeftToRight"] = false,
			},
			["width"] = 232,
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "value",
				["bottomOffset"] = 100,
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -41,
				["x"] = -106,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 1000,
				["scale"] = 100,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textVert"] = 2,
				["leftOffset"] = 0,
				["frameStrata"] = 2,
				["alpha"] = 100,
				["width"] = 51,
				["orient"] = "HORIZONTAL",
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["textX"] = 0,
				["textY"] = 0,
				["enable"] = true,
				["textHori"] = 2,
				["topOffset"] = 0,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 100,
				["y"] = 19,
				["x"] = -50,
				["justifyH"] = 2,
				["anchor"] = "Center",
				["scale"] = 100,
				["height"] = 12,
				["frameStrata"] = 2,
			},
			["model"] = {
				["zoom"] = 0,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 1,
				["clickThru"] = true,
				["justifyV"] = "CENTER",
				["width"] = 133,
				["y"] = -45,
				["x"] = -110,
				["justifyH"] = "CENTER",
				["enable"] = false,
				["anchor"] = "BottomLeft",
				["height"] = 197,
				["rotation"] = 0,
				["frameStrata"] = 2,
			},
			["height"] = 100,
			["buffs"] = {
				["scale"] = 64,
				["isLeftToRight"] = true,
				["columns"] = 6,
				["frameLayer"] = 1,
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["rows"] = 1,
				["alpha"] = 100,
				["enable"] = true,
				["y"] = 6,
				["x"] = 12,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomLeft",
				["isTopToBottom"] = false,
				["showBG"] = false,
				["frameStrata"] = 2,
			},
			["scale"] = 1,
			["background"] = {
				["enable"] = true,
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["b"] = 100,
					["g"] = 100,
					["r"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "TopRight",
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 2,
				["width"] = 51,
				["y"] = -26,
				["x"] = -111,
				["height"] = 41,
				["color"] = {
					["a"] = 0.5,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["scale"] = 100,
				["inset"] = 0,
			},
		},
	},
		Advanced = {
			["player"] = {
				["overlay"] = {
					["y"] = -2,
					["x"] = -21,
					["frameLayer"] = 1,
					["anchor"] = "Center",
					["frameStrata"] = 4,
					["enable"] = false,
				},
				["debuffs"] = {
					["color"] = {
						["a"] = 1,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["frameStrata"] = 2,
					["columns"] = 10,
					["frameLayer"] = 1,
					["scale"] = 66,
					["rows"] = 1,
					["alpha"] = 100,
					["isTopToBottom"] = true,
					["y"] = 76,
					["x"] = 0,
					["sort"] = "Duration",
					["spacing"] = 0,
					["anchor"] = "Top",
					["enable"] = true,
					["showBG"] = false,
					["isLeftToRight"] = true,
				},
				["resource"] = {
					["rotateIcons"] = 0,
					["color"] = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["spacing"] = 30,
					["anchor"] = "Left",
					["angle"] = 0,
					["showBG"] = true,
					["columns"] = 5,
					["compress"] = 0,
					["frameStrata"] = 2,
					["alpha"] = 100,
					["width"] = 60,
					["y"] = -5,
					["isTopToBottom"] = false,
					["style"] = "Bar",
					["frameLayer"] = 1,
					["height"] = 36,
					["x"] = 0,
					["scale"] = 106,
					["enable"] = true,
				},
				["altpower"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "Bottom",
					["format"] = "current",
					["bottomOffset"] = 100,
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 15,
					["x"] = 0,
					["arc"] = 0,
					["height"] = 15,
					["anchorText"] = "Center",
					["percent"] = true,
					["maxTextWidth"] = 300,
					["scale"] = 100,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["leftOffset"] = 0,
					["topOffset"] = 0,
					["textHori"] = 2,
					["frameStrata"] = 2,
					["alpha"] = 100,
					["width"] = 231,
					["textX"] = 0,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["textY"] = 0,
					["enable"] = true,
					["orient"] = "HORIZONTAL",
					["textVert"] = 2,
					["LifeTime"] = 0,
				},
				["cast"] = {
					["maxTextWidth"] = 98,
					["enable"] = true,
					["multi"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["textureName"] = "Blizzard",
					["textheight"] = 12,
					["Sparkarc"] = 0,
					["backdropOpacity"] = 50,
					["frameLevel"] = 2,
					["anchor"] = "Top",
					["textY"] = 0,
					["showBG"] = true,
					["CurveOffset"] = 0,
					["orient"] = "HORIZONTAL",
					["frameStrata"] = 2,
					["textX"] = 0,
					["frameLayer"] = 4,
					["x"] = 0,
					["y"] = 12,
					["alpha"] = 100,
					["width"] = 232,
					["yTextOffset"] = 0,
					["xTextOffset"] = 0,
					["mouseOverTooltip"] = true,
					["arc"] = 0,
					["height"] = 12,
					["anchorText"] = "Center",
					["scale"] = 100,
					["sparkY"] = 0,
				},
				["currency"] = {
					["color"] = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["Goal"] = {
					},
					["anchor"] = "BottomLeft",
					["showBG"] = false,
					["frameLayer"] = 1,
					["lifeTime_Track"] = {
						[""] = {
						},
						["Artifact Points"] = {
						},
						["Gold"] = {
						},
					},
					["x"] = 12,
					["frameStrata"] = 2,
					["width"] = 50,
					["y"] = 6,
					["ThisSession"] = {
						[""] = 0,
						["Artifact Points"] = 0,
						["Gold"] = 0,
					},
					["isTopToBottom"] = false,
					["scale"] = 64,
					["enable"] = false,
					["alpha"] = 100,
					["watchIndex"] = 2,
					["lifeTime"] = {
						[""] = 0,
						["Artifact Points"] = 0,
						["Gold"] = 0,
					},
				},
				["focus"] = {
					["usePortrait"] = true,
					["frameLayer"] = 20,
					["enable"] = false,
					["alpha"] = 100,
					["y"] = 0,
					["x"] = 0,
					["mouseOverTooltip"] = true,
					["anchor"] = "Left",
					["frameStrata"] = 3,
					["scale"] = 100,
				},
				["background"] = {
					["color"] = {
						["a"] = 0.5,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["textureName"] = "Blizzard Tooltip",
					["edgecolor"] = {
						["a"] = 100,
						["b"] = 100,
						["g"] = 100,
						["r"] = 100,
					},
					["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
					["anchor"] = "Center",
					["inset"] = 0,
					["edgeSize"] = 13,
					["frameLayer"] = 1,
					["bgPad"] = 0,
					["frameStrata"] = 2,
					["width"] = 103,
					["y"] = 0,
					["x"] = 0,
					["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
					["height"] = 100,
					["scale"] = 100,
					["enable"] = true,
					["ReactionColor"] = true,
				},
				["frameStrata"] = 4,
				["showInPetBattleUI"] = false,
				["threat"] = {
					["frameLayer"] = 1,
					["scale"] = 100,
					["justifyV"] = 1,
					["width"] = 35,
					["y"] = -11,
					["x"] = -10,
					["justifyH"] = 3,
					["height"] = 12,
					["frameStrata"] = 2,
					["anchor"] = "top",
					["enable"] = true,
				},
				["scale"] = 1,
				["power"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "Bottom",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["yTextOffset"] = 0,
					["x"] = 0,
					["arc"] = 0,
					["textHori"] = 2,
					["anchorText"] = "Center",
					["percent"] = true,
					["textY"] = 0,
					["scale"] = 100,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["topOffset"] = 0,
					["y"] = 0,
					["textVert"] = 2,
					["bottomOffset"] = 100,
					["leftOffset"] = 0,
					["frameStrata"] = 2,
					["alpha"] = 100,
					["width"] = 232,
					["maxTextWidth"] = 300,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["enable"] = true,
					["textX"] = 0,
					["xTextOffset"] = 0,
					["height"] = 15,
					["LifeTime"] = 0,
				},
				["frameLayer"] = 4,
				["showInOverrideUI"] = false,
				["icons"] = {
					["xShift"] = 0,
					["spin"] = -154,
					["enable"] = true,
					["anchor"] = "Top",
					["isTopToBottom"] = false,
					["isLeftToRight"] = false,
					["yShift"] = 0,
					["xFlex"] = 0,
					["spacing"] = 0,
					["space"] = -13,
					["angle"] = 227,
					["IsLeftToRight"] = false,
					["IsTopToBottom"] = true,
					["offset"] = 0,
					["yFlex"] = 0,
					["columns"] = 11,
					["compress"] = 0,
					["yArc"] = 0,
					["xArc"] = 0,
					["alpha"] = 100,
					["width"] = 45,
					["y"] = 47,
					["rings"] = 1,
					["style"] = "BAR",
					["frameLayer"] = 3,
					["height"] = 45,
					["scale"] = 101,
					["frameStrata"] = 2,
					["x"] = -2,
				},
				["width"] = 232,
				["padH"] = 3,
				["name"] = {
					["frameLayer"] = 1,
					["enable"] = true,
					["justifyV"] = 1,
					["width"] = 211,
					["y"] = 12,
					["x"] = 0,
					["justifyH"] = 1,
					["height"] = 12,
					["frameStrata"] = 2,
					["anchor"] = "TopLeft",
					["scale"] = 100,
				},
				["health"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "Top",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 0,
					["x"] = 0,
					["arc"] = 0,
					["textHori"] = 2,
					["anchorText"] = "Center",
					["percent"] = true,
					["maxTextWidth"] = 300,
					["scale"] = 100,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["topOffset"] = 0,
					["textX"] = 0,
					["height"] = 24,
					["bottomOffset"] = 100,
					["frameStrata"] = 2,
					["alpha"] = 100,
					["width"] = 232,
					["classColor"] = false,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["leftOffset"] = 0,
					["textY"] = 0,
					["enable"] = true,
					["textVert"] = 2,
					["LifeTime"] = 0,
				},
				["model"] = {
					["zoom"] = 0,
					["frameLevel"] = 1,
					["frameLayer"] = 1,
					["scale"] = 100,
					["frameStrata"] = 2,
					["justifyV"] = "CENTER",
					["width"] = 190,
					["rotation"] = 0,
					["x"] = 0,
					["justifyH"] = "CENTER",
					["clickThru"] = true,
					["anchor"] = "Top",
					["enable"] = true,
					["height"] = 190,
					["y"] = 200,
				},
				["height"] = 52,
				["buffs"] = {
					["scale"] = 66,
					["frameStrata"] = 2,
					["columns"] = 10,
					["frameLayer"] = 1,
					["color"] = {
						["a"] = 1,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["rows"] = 1,
					["alpha"] = 100,
					["x"] = 0,
					["y"] = 53,
					["isTopToBottom"] = false,
					["sort"] = "Duration",
					["spacing"] = 0,
					["anchor"] = "Top",
					["enable"] = true,
					["showBG"] = false,
					["isLeftToRight"] = true,
				},
				["padW"] = 3,
				["level"] = {
					["frameLayer"] = 1,
					["scale"] = 100,
					["justifyV"] = 1,
					["width"] = 25,
					["y"] = 12,
					["x"] = 0,
					["justifyH"] = 3,
					["anchor"] = "TopRight",
					["frameStrata"] = 2,
					["height"] = 12,
					["enable"] = true,
				},
			},
			["focus"] = {
				["overlay"] = {
					["y"] = -2,
					["x"] = -21,
					["frameLayer"] = 1,
					["enable"] = false,
					["frameStrata"] = 4,
					["anchor"] = "Center",
				},
				["debuffs"] = {
					["color"] = {
						["a"] = 1,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["rows"] = 2,
					["sort"] = "Duration",
					["spacing"] = 0,
					["anchor"] = "Left",
					["showBG"] = false,
					["columns"] = 9,
					["frameLayer"] = 1,
					["isLeftToRight"] = false,
					["y"] = -21,
					["isTopToBottom"] = false,
					["x"] = -182,
					["reverse"] = false,
					["enable"] = true,
					["scale"] = 61,
					["frameStrata"] = 2,
					["alpha"] = 100,
				},
				["resource"] = {
					["rotateIcons"] = 0,
					["enable"] = true,
					["spacing"] = 3,
					["anchor"] = "Bottom",
					["angle"] = 0,
					["showBG"] = false,
					["columns"] = 5,
					["compress"] = 0,
					["alpha"] = 100,
					["frameStrata"] = 2,
					["width"] = 50,
					["y"] = 11,
					["isTopToBottom"] = false,
					["style"] = "Bar",
					["frameLayer"] = 1,
					["height"] = 50,
					["x"] = 31,
					["scale"] = 91,
					["color"] = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
				},
				["altpower"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "BottomRight",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 15,
					["x"] = 0,
					["arc"] = 0,
					["height"] = 15,
					["anchorText"] = "Center",
					["percent"] = true,
					["textY"] = 0,
					["enable"] = true,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["textVert"] = 2,
					["topOffset"] = 0,
					["textHori"] = 2,
					["textX"] = 0,
					["frameStrata"] = 2,
					["width"] = 169.871765136719,
					["scale"] = 100,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["maxTextWidth"] = 300,
					["bottomOffset"] = 100,
					["alpha"] = 100,
					["leftOffset"] = 0,
					["LifeTime"] = 0,
				},
				["cast"] = {
					["maxTextWidth"] = 98,
					["enable"] = true,
					["multi"] = true,
					["showBG"] = true,
					["sparkY"] = 0,
					["textheight"] = 12,
					["Sparkarc"] = 0,
					["backdropOpacity"] = 50,
					["frameLevel"] = 2,
					["anchor"] = "Right",
					["textY"] = 0,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["x"] = 0,
					["orient"] = "HORIZONTAL",
					["frameStrata"] = 2,
					["textX"] = 0,
					["frameLayer"] = 4,
					["CurveOffset"] = 0,
					["yTextOffset"] = 0,
					["alpha"] = 100,
					["width"] = 140,
					["y"] = 2,
					["xTextOffset"] = 0,
					["mouseOverTooltip"] = true,
					["arc"] = 0,
					["height"] = 26,
					["anchorText"] = "Center",
					["scale"] = 100,
					["textureName"] = "Blizzard",
				},
				["currency"] = {
					["enable"] = false,
					["Goal"] = {
					},
					["anchor"] = "BottomLeft",
					["showBG"] = false,
					["frameLayer"] = 1,
					["lifeTime_Track"] = {
						[""] = {
						},
						["Artifact Points"] = {
						},
						["Gold"] = {
						},
					},
					["x"] = 12,
					["alpha"] = 100,
					["width"] = 50,
					["y"] = 6,
					["isTopToBottom"] = false,
					["ThisSession"] = {
						[""] = 0,
						["Artifact Points"] = 0,
						["Gold"] = 0,
					},
					["color"] = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["scale"] = 64,
					["frameStrata"] = 2,
					["watchIndex"] = 2,
					["lifeTime"] = {
						[""] = 0,
						["Artifact Points"] = 0,
						["Gold"] = 0,
					},
				},
				["focus"] = {
					["usePortrait"] = true,
					["frameLayer"] = 20,
					["scale"] = 51,
					["alpha"] = 100,
					["y"] = 3,
					["x"] = 0,
					["mouseOverTooltip"] = true,
					["anchor"] = "Left",
					["frameStrata"] = 3,
					["enable"] = true,
				},
				["level"] = {
					["frameLayer"] = 1,
					["scale"] = 100,
					["justifyV"] = 2,
					["width"] = 25,
					["y"] = 4,
					["x"] = 0,
					["justifyH"] = 3,
					["height"] = 27,
					["frameStrata"] = 2,
					["enable"] = true,
					["anchor"] = "Right",
				},
				["background"] = {
					["color"] = {
						["a"] = 0.5,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["textureName"] = "Blizzard Tooltip",
					["edgecolor"] = {
						["a"] = 100,
						["b"] = 100,
						["g"] = 100,
						["r"] = 100,
					},
					["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
					["anchor"] = "Center",
					["inset"] = 0,
					["edgeSize"] = 13,
					["frameLayer"] = 1,
					["bgPad"] = 0,
					["frameStrata"] = 2,
					["width"] = 102,
					["y"] = 0,
					["x"] = 0,
					["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
					["height"] = 100,
					["scale"] = 100,
					["enable"] = true,
					["ReactionColor"] = false,
				},
				["showInPetBattleUI"] = false,
				["threat"] = {
					["frameLayer"] = 1,
					["scale"] = 100,
					["justifyV"] = 1,
					["width"] = 35,
					["y"] = -11,
					["x"] = -10,
					["justifyH"] = 3,
					["height"] = 12,
					["frameStrata"] = 2,
					["anchor"] = "top",
					["enable"] = true,
				},
				["scale"] = 1,
				["frameLayer"] = 4,
				["power"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "BottomRight",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 0,
					["xTextOffset"] = 0,
					["arc"] = 0,
					["height"] = 15,
					["anchorText"] = "Center",
					["percent"] = true,
					["maxTextWidth"] = 300,
					["scale"] = 100,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["topOffset"] = 0,
					["x"] = 0,
					["textVert"] = 2,
					["bottomOffset"] = 100,
					["leftOffset"] = 0,
					["frameStrata"] = 2,
					["alpha"] = 100,
					["width"] = 170,
					["textY"] = 0,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["enable"] = true,
					["textX"] = 0,
					["textHori"] = 2,
					["yTextOffset"] = 0,
					["LifeTime"] = 0,
				},
				["showInOverrideUI"] = false,
				["frameStrata"] = 4,
				["width"] = 170,
				["height"] = 80,
				["health"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "TopRight",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 0,
					["x"] = 0,
					["arc"] = 0,
					["height"] = 24,
					["anchorText"] = "Center",
					["percent"] = true,
					["textY"] = 0,
					["enable"] = true,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["topOffset"] = 0,
					["textVert"] = 2,
					["textHori"] = 2,
					["bottomOffset"] = 100,
					["alpha"] = 100,
					["frameStrata"] = 2,
					["width"] = 170,
					["classColor"] = false,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["leftOffset"] = 0,
					["maxTextWidth"] = 300,
					["scale"] = 100,
					["textX"] = 0,
					["LifeTime"] = 0,
				},
				["name"] = {
					["frameLayer"] = 1,
					["enable"] = true,
					["justifyV"] = 2,
					["width"] = 119,
					["y"] = 4,
					["x"] = 32,
					["justifyH"] = 1,
					["anchor"] = "Left",
					["frameStrata"] = 2,
					["scale"] = 100,
					["height"] = 27,
				},
				["model"] = {
					["frameStrata"] = 2,
					["zoom"] = 0,
					["frameLevel"] = 1,
					["frameLayer"] = 1,
					["scale"] = 100,
					["rotation"] = 31.025447845459,
					["justifyV"] = "CENTER",
					["width"] = 190,
					["y"] = 186.698364257813,
					["x"] = 41,
					["justifyH"] = "CENTER",
					["enable"] = true,
					["anchor"] = "TopRight",
					["height"] = 190,
					["deathEffect"] = false,
					["clickThru"] = true,
				},
				["padH"] = 3,
				["buffs"] = {
					["color"] = {
						["a"] = 1,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["frameStrata"] = 2,
					["columns"] = 9,
					["frameLayer"] = 1,
					["scale"] = 61,
					["rows"] = 2,
					["alpha"] = 100,
					["isTopToBottom"] = true,
					["y"] = 21,
					["x"] = -182,
					["sort"] = "Duration",
					["spacing"] = 0,
					["anchor"] = "Left",
					["enable"] = true,
					["showBG"] = false,
					["isLeftToRight"] = false,
				},
				["icons"] = {
					["xShift"] = 0,
					["yShift"] = 0,
					["anchor"] = "Top",
					["scale"] = 101,
					["x"] = -2,
					["isLeftToRight"] = false,
					["offset"] = 0,
					["columns"] = 11,
					["frameLayer"] = 3,
					["IsTopToBottom"] = true,
					["spacing"] = 0,
					["space"] = -13,
					["angle"] = 227,
					["alpha"] = 100,
					["xArc"] = 0,
					["xFlex"] = 0,
					["yFlex"] = 0,
					["s"] = false,
					["compress"] = 0,
					["IsLeftToRight"] = false,
					["rings"] = 1,
					["frameStrata"] = 2,
					["width"] = 45,
					["y"] = 47,
					["isTopToBottom"] = false,
					["style"] = "BAR",
					["reverse"] = false,
					["height"] = 45,
					["spin"] = -154,
					["enable"] = true,
					["yArc"] = 0,
				},
				["padW"] = 3,
			},
			["target"] = {
				["overlay"] = {
					["y"] = -2,
					["x"] = -21,
					["frameLayer"] = 1,
					["enable"] = false,
					["frameStrata"] = 4,
					["anchor"] = "Center",
				},
				["debuffs"] = {
					["enable"] = true,
					["rows"] = 2,
					["sort"] = "Duration",
					["spacing"] = 0,
					["anchor"] = "Left",
					["showBG"] = false,
					["columns"] = 9,
					["frameLayer"] = 1,
					["isLeftToRight"] = false,
					["y"] = -21,
					["isTopToBottom"] = false,
					["x"] = -182,
					["reverse"] = false,
					["frameStrata"] = 2,
					["scale"] = 61,
					["color"] = {
						["a"] = 1,
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["alpha"] = 100,
				},
				["resource"] = {
					["rotateIcons"] = 0,
					["color"] = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["spacing"] = 3,
					["anchor"] = "Bottom",
					["angle"] = 0,
					["showBG"] = false,
					["columns"] = 5,
					["compress"] = 0,
					["enable"] = true,
					["alpha"] = 100,
					["width"] = 50,
					["y"] = 11,
					["isTopToBottom"] = false,
					["style"] = "Bar",
					["scale"] = 91,
					["height"] = 50,
					["x"] = 31,
					["frameLayer"] = 1,
					["frameStrata"] = 2,
				},
				["scale"] = 1,
				["cast"] = {
					["maxTextWidth"] = 98,
					["enable"] = true,
					["multi"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["textheight"] = 12,
					["textureName"] = "Blizzard",
					["Sparkarc"] = 0,
					["backdropOpacity"] = 50,
					["frameLevel"] = 2,
					["anchor"] = "Right",
					["textY"] = 0,
					["showBG"] = true,
					["x"] = 0,
					["orient"] = "HORIZONTAL",
					["frameStrata"] = 2,
					["textX"] = 0,
					["frameLayer"] = 4,
					["CurveOffset"] = 0,
					["yTextOffset"] = 0,
					["alpha"] = 100,
					["width"] = 140,
					["y"] = 2,
					["xTextOffset"] = 0,
					["mouseOverTooltip"] = true,
					["arc"] = 0,
					["height"] = 26,
					["anchorText"] = "Center",
					["scale"] = 100,
					["sparkY"] = 0,
				},
				["currency"] = {
					["scale"] = 64,
					["Goal"] = {
					},
					["anchor"] = "BottomLeft",
					["lifeTime_Track"] = {
						[""] = {
						},
						["Artifact Points"] = {
						},
						["Gold"] = {
						},
					},
					["frameLayer"] = 1,
					["showBG"] = false,
					["x"] = 12,
					["frameStrata"] = 2,
					["width"] = 50,
					["y"] = 6,
					["isTopToBottom"] = false,
					["alpha"] = 100,
					["enable"] = false,
					["color"] = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["ThisSession"] = {
						[""] = 0,
						["Artifact Points"] = 0,
						["Gold"] = 0,
					},
					["watchIndex"] = 2,
					["lifeTime"] = {
						[""] = 0,
						["Artifact Points"] = 0,
						["Gold"] = 0,
					},
				},
				["focus"] = {
					["usePortrait"] = true,
					["frameLayer"] = 20,
					["scale"] = 51,
					["alpha"] = 100,
					["y"] = 3,
					["x"] = 0,
					["mouseOverTooltip"] = true,
					["anchor"] = "Left",
					["frameStrata"] = 3,
					["enable"] = true,
				},
				["level"] = {
					["frameLayer"] = 1,
					["scale"] = 100,
					["justifyV"] = 2,
					["width"] = 25,
					["y"] = 4,
					["x"] = 0,
					["justifyH"] = 3,
					["height"] = 27,
					["frameStrata"] = 2,
					["enable"] = true,
					["anchor"] = "Right",
				},
				["background"] = {
					["color"] = {
						["a"] = 0.5,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["textureName"] = "Blizzard Tooltip",
					["edgecolor"] = {
						["a"] = 100,
						["b"] = 100,
						["g"] = 100,
						["r"] = 100,
					},
					["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
					["anchor"] = "Center",
					["inset"] = 0,
					["edgeSize"] = 13,
					["frameLayer"] = 1,
					["bgPad"] = 0,
					["frameStrata"] = 2,
					["width"] = 102,
					["y"] = 0,
					["x"] = 0,
					["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
					["height"] = 100,
					["scale"] = 100,
					["enable"] = true,
					["ReactionColor"] = false,
				},
				["showInPetBattleUI"] = false,
				["threat"] = {
					["frameLayer"] = 1,
					["scale"] = 100,
					["justifyV"] = 1,
					["width"] = 35,
					["y"] = -11,
					["x"] = -10,
					["justifyH"] = 3,
					["height"] = 12,
					["frameStrata"] = 2,
					["anchor"] = "top",
					["enable"] = true,
				},
				["icons"] = {
					["xShift"] = 0,
					["yShift"] = 0,
					["anchor"] = "Top",
					["scale"] = 101,
					["x"] = -2,
					["frameStrata"] = 2,
					["offset"] = 0,
					["columns"] = 11,
					["frameLayer"] = 3,
					["IsTopToBottom"] = true,
					["spacing"] = 0,
					["space"] = -13,
					["angle"] = 227,
					["alpha"] = 100,
					["xArc"] = 0,
					["xFlex"] = 0,
					["yFlex"] = 0,
					["s"] = false,
					["compress"] = 0,
					["IsLeftToRight"] = false,
					["rings"] = 1,
					["isLeftToRight"] = false,
					["width"] = 45,
					["y"] = 47,
					["isTopToBottom"] = false,
					["style"] = "BAR",
					["reverse"] = false,
					["height"] = 45,
					["spin"] = -154,
					["enable"] = true,
					["yArc"] = 0,
				},
				["power"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "BottomRight",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 0,
					["xTextOffset"] = 0,
					["arc"] = 0,
					["height"] = 15,
					["anchorText"] = "Center",
					["percent"] = true,
					["maxTextWidth"] = 300,
					["scale"] = 100,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["topOffset"] = 0,
					["x"] = 0,
					["textVert"] = 2,
					["bottomOffset"] = 100,
					["leftOffset"] = 0,
					["frameStrata"] = 2,
					["alpha"] = 100,
					["width"] = 170,
					["textY"] = 0,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["enable"] = true,
					["textX"] = 0,
					["textHori"] = 2,
					["yTextOffset"] = 0,
					["LifeTime"] = 0,
				},
				["frameLayer"] = 4,
				["showInOverrideUI"] = false,
				["frameStrata"] = 4,
				["width"] = 170,
				["height"] = 80,
				["health"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "TopRight",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 0,
					["x"] = 0,
					["arc"] = 0,
					["height"] = 24,
					["anchorText"] = "Center",
					["percent"] = true,
					["textY"] = 0,
					["enable"] = true,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["topOffset"] = 0,
					["textVert"] = 2,
					["textHori"] = 2,
					["bottomOffset"] = 100,
					["frameStrata"] = 2,
					["alpha"] = 100,
					["width"] = 170,
					["classColor"] = false,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["leftOffset"] = 0,
					["maxTextWidth"] = 300,
					["scale"] = 100,
					["textX"] = 0,
					["LifeTime"] = 0,
				},
				["name"] = {
					["frameLayer"] = 1,
					["enable"] = true,
					["justifyV"] = 2,
					["width"] = 119,
					["y"] = 4,
					["x"] = 32,
					["justifyH"] = 1,
					["anchor"] = "Left",
					["frameStrata"] = 2,
					["scale"] = 100,
					["height"] = 27,
				},
				["model"] = {
					["frameStrata"] = 2,
					["zoom"] = 0,
					["frameLevel"] = 1,
					["frameLayer"] = 1,
					["scale"] = 100,
					["rotation"] = 31.025447845459,
					["justifyV"] = "CENTER",
					["width"] = 190,
					["y"] = 186.698364257813,
					["x"] = 41,
					["justifyH"] = "CENTER",
					["enable"] = true,
					["anchor"] = "TopRight",
					["height"] = 190,
					["deathEffect"] = false,
					["clickThru"] = true,
				},
				["padH"] = 3,
				["buffs"] = {
					["alpha"] = 100,
					["frameStrata"] = 2,
					["columns"] = 9,
					["frameLayer"] = 1,
					["color"] = {
						["a"] = 1,
						["r"] = 0,
						["g"] = 0,
						["b"] = 0,
					},
					["rows"] = 2,
					["isLeftToRight"] = false,
					["isTopToBottom"] = true,
					["y"] = 21,
					["x"] = -182,
					["sort"] = "Duration",
					["spacing"] = 0,
					["anchor"] = "Left",
					["enable"] = true,
					["showBG"] = false,
					["scale"] = 61,
				},
				["altpower"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "BottomRight",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 15,
					["x"] = 0,
					["arc"] = 0,
					["height"] = 15,
					["anchorText"] = "Center",
					["percent"] = true,
					["textY"] = 0,
					["enable"] = true,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["textVert"] = 2,
					["topOffset"] = 0,
					["textHori"] = 2,
					["textX"] = 0,
					["frameStrata"] = 2,
					["width"] = 169.871765136719,
					["scale"] = 100,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["maxTextWidth"] = 300,
					["bottomOffset"] = 100,
					["alpha"] = 100,
					["leftOffset"] = 0,
					["LifeTime"] = 0,
				},
				["padW"] = 3,
			},
			["focustarget"] = {
				["overlay"] = {
					["y"] = -2,
					["x"] = 21,
					["frameLayer"] = 1,
					["enable"] = false,
					["frameStrata"] = 4,
					["anchor"] = "Center",
				},
				["debuffs"] = {
					["color"] = {
						["a"] = 1,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["rows"] = 2,
					["sort"] = "Duration",
					["spacing"] = 0,
					["anchor"] = "Right",
					["showBG"] = false,
					["columns"] = 9,
					["frameLayer"] = 1,
					["isLeftToRight"] = false,
					["y"] = -21,
					["isTopToBottom"] = false,
					["x"] = 182,
					["reverse"] = false,
					["enable"] = true,
					["scale"] = 61,
					["frameStrata"] = 2,
					["alpha"] = 100,
				},
				["resource"] = {
					["rotateIcons"] = 0,
					["enable"] = true,
					["spacing"] = 3,
					["anchor"] = "Bottom",
					["angle"] = 0,
					["showBG"] = false,
					["columns"] = 5,
					["compress"] = 0,
					["alpha"] = 100,
					["frameStrata"] = 2,
					["width"] = 50,
					["y"] = 11,
					["isTopToBottom"] = false,
					["style"] = "Bar",
					["frameLayer"] = 1,
					["height"] = 50,
					["x"] = -31,
					["scale"] = 91,
					["color"] = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
				},
				["scale"] = 1,
				["cast"] = {
					["maxTextWidth"] = 98,
					["enable"] = true,
					["multi"] = true,
					["showBG"] = true,
					["sparkY"] = 0,
					["textheight"] = 12,
					["Sparkarc"] = 0,
					["backdropOpacity"] = 50,
					["frameLevel"] = 2,
					["anchor"] = "Left",
					["textY"] = 0,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["x"] = 0,
					["orient"] = "HORIZONTAL",
					["frameStrata"] = 2,
					["textX"] = 0,
					["frameLayer"] = 4,
					["CurveOffset"] = 0,
					["yTextOffset"] = 0,
					["alpha"] = 100,
					["width"] = 140,
					["y"] = 2,
					["xTextOffset"] = 0,
					["mouseOverTooltip"] = true,
					["arc"] = 0,
					["height"] = 26,
					["anchorText"] = "Center",
					["scale"] = 100,
					["textureName"] = "Blizzard",
				},
				["currency"] = {
					["enable"] = false,
					["Goal"] = {
					},
					["anchor"] = "BottomRight",
					["showBG"] = false,
					["frameLayer"] = 1,
					["lifeTime_Track"] = {
						[""] = {
						},
						["Artifact Points"] = {
						},
						["Gold"] = {
						},
					},
					["x"] = -12,
					["alpha"] = 100,
					["width"] = 50,
					["y"] = 6,
					["isTopToBottom"] = false,
					["ThisSession"] = {
						[""] = 0,
						["Artifact Points"] = 0,
						["Gold"] = 0,
					},
					["color"] = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["scale"] = 64,
					["frameStrata"] = 2,
					["watchIndex"] = 2,
					["lifeTime"] = {
						[""] = 0,
						["Artifact Points"] = 0,
						["Gold"] = 0,
					},
				},
				["focus"] = {
					["usePortrait"] = true,
					["frameLayer"] = 20,
					["scale"] = 51,
					["alpha"] = 100,
					["y"] = 3,
					["x"] = 0,
					["mouseOverTooltip"] = true,
					["anchor"] = "Right",
					["frameStrata"] = 3,
					["enable"] = true,
				},
				["level"] = {
					["frameLayer"] = 1,
					["scale"] = 100,
					["justifyV"] = 2,
					["width"] = 25,
					["y"] = 4,
					["x"] = 0,
					["justifyH"] = 1,
					["height"] = 27,
					["frameStrata"] = 2,
					["enable"] = true,
					["anchor"] = "Left",
				},
				["background"] = {
					["color"] = {
						["a"] = 0.5,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["textureName"] = "Blizzard Tooltip",
					["edgecolor"] = {
						["a"] = 100,
						["b"] = 100,
						["g"] = 100,
						["r"] = 100,
					},
					["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
					["anchor"] = "Center",
					["inset"] = 0,
					["edgeSize"] = 13,
					["frameLayer"] = 1,
					["bgPad"] = 0,
					["frameStrata"] = 2,
					["width"] = 102,
					["y"] = 0,
					["x"] = 0,
					["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
					["height"] = 100,
					["scale"] = 100,
					["enable"] = true,
					["ReactionColor"] = false,
				},
				["showInPetBattleUI"] = false,
				["threat"] = {
					["frameLayer"] = 1,
					["scale"] = 100,
					["justifyV"] = 1,
					["width"] = 35,
					["y"] = -11,
					["x"] = 10,
					["justifyH"] = 1,
					["height"] = 12,
					["frameStrata"] = 2,
					["anchor"] = "top",
					["enable"] = true,
				},
				["padW"] = 3,
				["power"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "BottomLeft",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 0,
					["xTextOffset"] = 0,
					["arc"] = 0,
					["height"] = 15,
					["anchorText"] = "Center",
					["percent"] = true,
					["maxTextWidth"] = 300,
					["scale"] = 100,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["topOffset"] = 0,
					["x"] = 0,
					["textVert"] = 2,
					["bottomOffset"] = 100,
					["leftOffset"] = 0,
					["frameStrata"] = 2,
					["alpha"] = 100,
					["width"] = 170,
					["textY"] = 0,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["enable"] = true,
					["textX"] = 0,
					["textHori"] = 2,
					["yTextOffset"] = 0,
					["LifeTime"] = 0,
				},
				["frameLayer"] = 4,
				["showInOverrideUI"] = false,
				["frameStrata"] = 4,
				["width"] = 170,
				["height"] = 80,
				["name"] = {
					["frameLayer"] = 1,
					["enable"] = true,
					["justifyV"] = 2,
					["width"] = 119,
					["y"] = 4,
					["x"] = -32,
					["justifyH"] = 3,
					["anchor"] = "Right",
					["frameStrata"] = 2,
					["scale"] = 100,
					["height"] = 27,
				},
				["health"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "TopLeft",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 0,
					["x"] = 0,
					["arc"] = 0,
					["height"] = 24,
					["anchorText"] = "Center",
					["percent"] = true,
					["textY"] = 0,
					["enable"] = true,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["topOffset"] = 0,
					["textVert"] = 2,
					["textHori"] = 2,
					["bottomOffset"] = 100,
					["alpha"] = 100,
					["frameStrata"] = 2,
					["width"] = 170,
					["classColor"] = false,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["leftOffset"] = 0,
					["maxTextWidth"] = 300,
					["scale"] = 100,
					["textX"] = 0,
					["LifeTime"] = 0,
				},
				["model"] = {
					["frameStrata"] = 2,
					["zoom"] = 0,
					["frameLevel"] = 1,
					["frameLayer"] = 1,
					["scale"] = 100,
					["rotation"] = 329,
					["justifyV"] = "CENTER",
					["width"] = 190,
					["y"] = 187,
					["x"] = -41,
					["justifyH"] = "CENTER",
					["enable"] = true,
					["anchor"] = "TopLeft",
					["height"] = 190,
					["deathEffect"] = false,
					["clickThru"] = true,
				},
				["padH"] = 3,
				["buffs"] = {
					["color"] = {
						["a"] = 1,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["frameStrata"] = 2,
					["columns"] = 9,
					["frameLayer"] = 1,
					["scale"] = 61,
					["rows"] = 2,
					["alpha"] = 100,
					["isTopToBottom"] = true,
					["y"] = 21,
					["x"] = 182,
					["sort"] = "Duration",
					["spacing"] = 0,
					["anchor"] = "Right",
					["enable"] = true,
					["showBG"] = false,
					["isLeftToRight"] = false,
				},
				["altpower"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "BottomLeft",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 15,
					["x"] = 0,
					["arc"] = 0,
					["height"] = 15,
					["anchorText"] = "Center",
					["percent"] = true,
					["textY"] = 0,
					["enable"] = true,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["textVert"] = 2,
					["topOffset"] = 0,
					["textHori"] = 2,
					["textX"] = 0,
					["frameStrata"] = 2,
					["width"] = 169.871765136719,
					["scale"] = 100,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["maxTextWidth"] = 300,
					["bottomOffset"] = 100,
					["alpha"] = 100,
					["leftOffset"] = 0,
					["LifeTime"] = 0,
				},
				["icons"] = {
					["xShift"] = 0,
					["yShift"] = 0,
					["anchor"] = "Top",
					["scale"] = 101,
					["x"] = 2,
					["isLeftToRight"] = false,
					["offset"] = 0,
					["columns"] = 11,
					["frameLayer"] = 3,
					["IsTopToBottom"] = true,
					["spacing"] = 0,
					["space"] = -13,
					["angle"] = 227,
					["alpha"] = 100,
					["xArc"] = 0,
					["xFlex"] = 0,
					["yFlex"] = 0,
					["s"] = false,
					["compress"] = 0,
					["IsLeftToRight"] = false,
					["rings"] = 1,
					["frameStrata"] = 2,
					["width"] = 45,
					["y"] = 47,
					["isTopToBottom"] = false,
					["style"] = "BAR",
					["reverse"] = false,
					["height"] = 45,
					["spin"] = -154,
					["enable"] = true,
					["yArc"] = 0,
				},
			},
			["targettarget"] = {
				["overlay"] = {
					["y"] = -2,
					["x"] = 21,
					["frameLayer"] = 1,
					["enable"] = false,
					["frameStrata"] = 4,
					["anchor"] = "Center",
				},
				["debuffs"] = {
					["color"] = {
						["a"] = 1,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["rows"] = 2,
					["sort"] = "Duration",
					["spacing"] = 0,
					["anchor"] = "Right",
					["showBG"] = false,
					["columns"] = 9,
					["frameLayer"] = 1,
					["isLeftToRight"] = false,
					["y"] = -21,
					["isTopToBottom"] = false,
					["x"] = 182,
					["reverse"] = false,
					["enable"] = true,
					["scale"] = 61,
					["frameStrata"] = 2,
					["alpha"] = 100,
				},
				["resource"] = {
					["rotateIcons"] = 0,
					["enable"] = true,
					["spacing"] = 3,
					["anchor"] = "Bottom",
					["angle"] = 0,
					["showBG"] = false,
					["columns"] = 5,
					["compress"] = 0,
					["alpha"] = 100,
					["frameStrata"] = 2,
					["width"] = 50,
					["y"] = 11,
					["isTopToBottom"] = false,
					["style"] = "Bar",
					["frameLayer"] = 1,
					["height"] = 50,
					["x"] = -31,
					["scale"] = 91,
					["color"] = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
				},
				["scale"] = 1,
				["cast"] = {
					["maxTextWidth"] = 98,
					["enable"] = true,
					["multi"] = true,
					["showBG"] = true,
					["sparkY"] = 0,
					["textheight"] = 12,
					["Sparkarc"] = 0,
					["backdropOpacity"] = 50,
					["frameLevel"] = 2,
					["anchor"] = "Left",
					["textY"] = 0,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["x"] = 0,
					["orient"] = "HORIZONTAL",
					["frameStrata"] = 2,
					["textX"] = 0,
					["frameLayer"] = 4,
					["CurveOffset"] = 0,
					["yTextOffset"] = 0,
					["alpha"] = 100,
					["width"] = 140,
					["y"] = 2,
					["xTextOffset"] = 0,
					["mouseOverTooltip"] = true,
					["arc"] = 0,
					["height"] = 26,
					["anchorText"] = "Center",
					["scale"] = 100,
					["textureName"] = "Blizzard",
				},
				["currency"] = {
					["enable"] = false,
					["Goal"] = {
					},
					["anchor"] = "BottomRight",
					["showBG"] = false,
					["frameLayer"] = 1,
					["lifeTime_Track"] = {
						[""] = {
						},
						["Artifact Points"] = {
						},
						["Gold"] = {
						},
					},
					["x"] = -12,
					["alpha"] = 100,
					["width"] = 50,
					["y"] = 6,
					["isTopToBottom"] = false,
					["ThisSession"] = {
						[""] = 0,
						["Artifact Points"] = 0,
						["Gold"] = 0,
					},
					["color"] = {
						["a"] = 1,
						["r"] = 1,
						["g"] = 1,
						["b"] = 1,
					},
					["scale"] = 64,
					["frameStrata"] = 2,
					["watchIndex"] = 2,
					["lifeTime"] = {
						[""] = 0,
						["Artifact Points"] = 0,
						["Gold"] = 0,
					},
				},
				["focus"] = {
					["usePortrait"] = true,
					["frameLayer"] = 20,
					["scale"] = 51,
					["alpha"] = 100,
					["y"] = 3,
					["x"] = 0,
					["mouseOverTooltip"] = true,
					["anchor"] = "Right",
					["frameStrata"] = 3,
					["enable"] = true,
				},
				["level"] = {
					["frameLayer"] = 1,
					["scale"] = 100,
					["justifyV"] = 2,
					["width"] = 25,
					["y"] = 4,
					["x"] = 0,
					["justifyH"] = 1,
					["height"] = 27,
					["frameStrata"] = 2,
					["enable"] = true,
					["anchor"] = "Left",
				},
				["background"] = {
					["color"] = {
						["a"] = 0.5,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["textureName"] = "Blizzard Tooltip",
					["edgecolor"] = {
						["a"] = 100,
						["b"] = 100,
						["g"] = 100,
						["r"] = 100,
					},
					["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
					["anchor"] = "Center",
					["inset"] = 0,
					["edgeSize"] = 13,
					["frameLayer"] = 1,
					["bgPad"] = 0,
					["frameStrata"] = 2,
					["width"] = 102,
					["y"] = 0,
					["x"] = 0,
					["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
					["height"] = 100,
					["scale"] = 100,
					["enable"] = true,
					["ReactionColor"] = false,
				},
				["showInPetBattleUI"] = false,
				["threat"] = {
					["frameLayer"] = 1,
					["scale"] = 100,
					["justifyV"] = 1,
					["width"] = 35,
					["y"] = -11,
					["x"] = 10,
					["justifyH"] = 1,
					["height"] = 12,
					["frameStrata"] = 2,
					["anchor"] = "top",
					["enable"] = true,
				},
				["altpower"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "BottomLeft",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 15,
					["x"] = 0,
					["arc"] = 0,
					["height"] = 15,
					["anchorText"] = "Center",
					["percent"] = true,
					["textY"] = 0,
					["enable"] = true,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["textVert"] = 2,
					["topOffset"] = 0,
					["textHori"] = 2,
					["textX"] = 0,
					["frameStrata"] = 2,
					["width"] = 169.871765136719,
					["scale"] = 100,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["maxTextWidth"] = 300,
					["bottomOffset"] = 100,
					["alpha"] = 100,
					["leftOffset"] = 0,
					["LifeTime"] = 0,
				},
				["frameLayer"] = 4,
				["power"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "BottomLeft",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 0,
					["xTextOffset"] = 0,
					["arc"] = 0,
					["height"] = 15,
					["anchorText"] = "Center",
					["percent"] = true,
					["maxTextWidth"] = 300,
					["scale"] = 100,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["topOffset"] = 0,
					["x"] = 0,
					["textVert"] = 2,
					["bottomOffset"] = 100,
					["leftOffset"] = 0,
					["frameStrata"] = 2,
					["alpha"] = 100,
					["width"] = 170,
					["textY"] = 0,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["enable"] = true,
					["textX"] = 0,
					["textHori"] = 2,
					["yTextOffset"] = 0,
					["LifeTime"] = 0,
				},
				["showInOverrideUI"] = false,
				["icons"] = {
					["xShift"] = 0,
					["yShift"] = 0,
					["anchor"] = "Top",
					["scale"] = 101,
					["x"] = 2,
					["isLeftToRight"] = false,
					["offset"] = 0,
					["columns"] = 11,
					["frameLayer"] = 3,
					["IsTopToBottom"] = true,
					["spacing"] = 0,
					["space"] = -13,
					["angle"] = 227,
					["alpha"] = 100,
					["xArc"] = 0,
					["xFlex"] = 0,
					["yFlex"] = 0,
					["s"] = false,
					["compress"] = 0,
					["IsLeftToRight"] = false,
					["rings"] = 1,
					["frameStrata"] = 2,
					["width"] = 45,
					["y"] = 47,
					["isTopToBottom"] = false,
					["style"] = "BAR",
					["reverse"] = false,
					["height"] = 45,
					["spin"] = -154,
					["enable"] = true,
					["yArc"] = 0,
				},
				["width"] = 170,
				["height"] = 80,
				["health"] = {
					["prevOrient"] = "HORIZONTAL",
					["CurrentPlayTime"] = 0,
					["rightOffset"] = 100,
					["backdropOpacity"] = 50,
					["anchor"] = "TopLeft",
					["format"] = "current",
					["orient"] = "HORIZONTAL",
					["frameLayer"] = 1,
					["mouseover"] = "percent",
					["y"] = 0,
					["x"] = 0,
					["arc"] = 0,
					["height"] = 24,
					["anchorText"] = "Center",
					["percent"] = true,
					["textY"] = 0,
					["enable"] = true,
					["justifyV"] = "CENTER",
					["textureName"] = "Raid",
					["justifyH"] = "CENTER",
					["drop"] = true,
					["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
					["topOffset"] = 0,
					["textVert"] = 2,
					["textHori"] = 2,
					["bottomOffset"] = 100,
					["alpha"] = 100,
					["frameStrata"] = 2,
					["width"] = 170,
					["classColor"] = false,
					["CurveOffset"] = 0,
					["mouseOverTooltip"] = true,
					["leftOffset"] = 0,
					["maxTextWidth"] = 300,
					["scale"] = 100,
					["textX"] = 0,
					["LifeTime"] = 0,
				},
				["name"] = {
					["frameLayer"] = 1,
					["enable"] = true,
					["justifyV"] = 2,
					["width"] = 119,
					["y"] = 4,
					["x"] = -32,
					["justifyH"] = 3,
					["anchor"] = "Right",
					["frameStrata"] = 2,
					["scale"] = 100,
					["height"] = 27,
				},
				["model"] = {
					["frameStrata"] = 2,
					["zoom"] = 0,
					["frameLevel"] = 1,
					["frameLayer"] = 1,
					["scale"] = 100,
					["rotation"] = 329,
					["justifyV"] = "CENTER",
					["width"] = 190,
					["y"] = 187,
					["x"] = -41,
					["justifyH"] = "CENTER",
					["enable"] = true,
					["anchor"] = "TopLeft",
					["height"] = 190,
					["deathEffect"] = false,
					["clickThru"] = true,
				},
				["padH"] = 3,
				["buffs"] = {
					["color"] = {
						["a"] = 1,
						["b"] = 0,
						["g"] = 0,
						["r"] = 0,
					},
					["frameStrata"] = 2,
					["columns"] = 9,
					["frameLayer"] = 1,
					["scale"] = 61,
					["rows"] = 2,
					["alpha"] = 100,
					["isTopToBottom"] = true,
					["y"] = 21,
					["x"] = 182,
					["sort"] = "Duration",
					["spacing"] = 0,
					["anchor"] = "Right",
					["enable"] = true,
					["showBG"] = false,
					["isLeftToRight"] = false,
				},
				["frameStrata"] = 4,
				["padW"] = 3,
			},
			["playerpet"] = {
			["overlay"] = {
				["y"] = -1,
				["x"] = 11,
				["frameLayer"] = 3,
				["enable"] = true,
				["frameStrata"] = 4,
				["anchor"] = "Center",
			},
			["debuffs"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 0.0666666666666667,
					["g"] = 1,
					["r"] = 0,
				},
				["rows"] = 1,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "Bottom",
				["showBG"] = false,
				["columns"] = 6,
				["frameLayer"] = 1,
				["isLeftToRight"] = true,
				["y"] = -39,
				["isTopToBottom"] = true,
				["x"] = -39,
				["reverse"] = false,
				["enable"] = true,
				["scale"] = 64,
				["frameStrata"] = 5,
				["alpha"] = 100,
			},
			["resource"] = {
				["rotateIcons"] = 0,
				["enable"] = true,
				["spacing"] = 3,
				["anchor"] = "Bottom",
				["angle"] = 0,
				["showBG"] = false,
				["columns"] = 5,
				["compress"] = 0,
				["alpha"] = 100,
				["frameStrata"] = 2,
				["width"] = 50,
				["y"] = 11,
				["isTopToBottom"] = false,
				["style"] = "Bar",
				["frameLayer"] = 1,
				["height"] = 50,
				["x"] = -31,
				["scale"] = 91,
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
			},
			["altpower"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -69,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["textVert"] = 2,
				["topOffset"] = 0,
				["textHori"] = 2,
				["textX"] = 0,
				["frameStrata"] = 3,
				["width"] = 126,
				["scale"] = 91,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["maxTextWidth"] = 300,
				["bottomOffset"] = 100,
				["alpha"] = 100,
				["leftOffset"] = 0,
				["LifeTime"] = 0,
			},
			["padW"] = 3,
			["currency"] = {
				["enable"] = false,
				["Goal"] = {
				},
				["anchor"] = "BottomRight",
				["showBG"] = false,
				["frameLayer"] = 1,
				["lifeTime_Track"] = {
					[""] = {
					},
					["Artifact Points"] = {
					},
					["Gold"] = {
					},
				},
				["x"] = -12,
				["alpha"] = 100,
				["width"] = 50,
				["y"] = 6,
				["isTopToBottom"] = false,
				["ThisSession"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
				["color"] = {
					["a"] = 1,
					["r"] = 1,
					["g"] = 1,
					["b"] = 1,
				},
				["scale"] = 64,
				["frameStrata"] = 2,
				["watchIndex"] = 2,
				["lifeTime"] = {
					[""] = 0,
					["Artifact Points"] = 0,
					["Gold"] = 0,
				},
			},
			["focus"] = {
				["usePortrait"] = true,
				["frameLayer"] = 10,
				["scale"] = 100,
				["alpha"] = 100,
				["y"] = -14,
				["x"] = -31,
				["mouseOverTooltip"] = true,
				["anchor"] = "TopRight",
				["frameStrata"] = 3,
				["enable"] = true,
			},
			["background"] = {
				["color"] = {
					["a"] = 0.5,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["textureName"] = "Blizzard Tooltip",
				["edgecolor"] = {
					["a"] = 100,
					["b"] = 100,
					["g"] = 100,
					["r"] = 100,
				},
				["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
				["anchor"] = "TopRight",
				["inset"] = 0,
				["edgeSize"] = 13,
				["frameLayer"] = 1,
				["bgPad"] = 0,
				["frameStrata"] = 3,
				["width"] = 50,
				["y"] = -23,
				["x"] = -101,
				["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
				["height"] = 21,
				["scale"] = 100,
				["enable"] = true,
				["ReactionColor"] = true,
			},
			["level"] = {
				["frameLayer"] = 3,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 25,
				["y"] = -19,
				["x"] = 72,
				["justifyH"] = 2,
				["height"] = 12,
				["frameStrata"] = 4,
				["enable"] = true,
				["anchor"] = "Center",
			},
			["showInPetBattleUI"] = false,
			["threat"] = {
				["frameLayer"] = 1,
				["scale"] = 100,
				["justifyV"] = 1,
				["width"] = 35,
				["y"] = -6,
				["x"] = 10,
				["justifyH"] = 1,
				["height"] = 12,
				["frameStrata"] = 2,
				["anchor"] = "top",
				["enable"] = true,
			},
			["frameStrata"] = 4,
			["frameLayer"] = 4,
			["power"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 1,
				["mouseover"] = "value",
				["y"] = -56,
				["xTextOffset"] = 0,
				["arc"] = 0,
				["height"] = 8,
				["anchorText"] = "Center",
				["percent"] = true,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["topOffset"] = 0,
				["x"] = -98,
				["textVert"] = 2,
				["bottomOffset"] = 100,
				["leftOffset"] = 0,
				["frameStrata"] = 3,
				["alpha"] = 100,
				["width"] = 127,
				["textY"] = 0,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["enable"] = true,
				["textX"] = 0,
				["textHori"] = 2,
				["yTextOffset"] = 0,
				["LifeTime"] = 0,
			},
			["showInOverrideUI"] = false,
			["icons"] = {
				["xShift"] = 0,
				["yShift"] = 0,
				["anchor"] = "Right",
				["scale"] = 101,
				["x"] = -35,
				["isLeftToRight"] = false,
				["offset"] = 0,
				["columns"] = 8,
				["frameLayer"] = 5,
				["IsTopToBottom"] = true,
				["spacing"] = 7.99036026000977,
				["space"] = -13,
				["angle"] = 227,
				["alpha"] = 100,
				["xArc"] = 0,
				["xFlex"] = 0,
				["yFlex"] = 0,
				["s"] = false,
				["compress"] = 0,
				["IsLeftToRight"] = false,
				["rings"] = 1,
				["frameStrata"] = 4,
				["width"] = 45,
				["y"] = 4,
				["isTopToBottom"] = false,
				["style"] = "ROUND",
				["reverse"] = false,
				["height"] = 45,
				["spin"] = 137.513977050781,
				["enable"] = true,
				["yArc"] = 0,
			},
			["width"] = 232,
			["height"] = 100,
			["health"] = {
				["prevOrient"] = "HORIZONTAL",
				["CurrentPlayTime"] = 0,
				["rightOffset"] = 100,
				["backdropOpacity"] = 50,
				["anchor"] = "TopRight",
				["format"] = "percent",
				["orient"] = "HORIZONTAL",
				["frameLayer"] = 4,
				["mouseover"] = "value",
				["y"] = -43,
				["x"] = -99,
				["arc"] = 0,
				["height"] = 12,
				["anchorText"] = "Center",
				["percent"] = true,
				["textY"] = 0,
				["enable"] = true,
				["justifyV"] = "CENTER",
				["textureName"] = "Raid",
				["justifyH"] = "CENTER",
				["drop"] = true,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["topOffset"] = 0,
				["textVert"] = 2,
				["textHori"] = 2,
				["bottomOffset"] = 100,
				["alpha"] = 100,
				["frameStrata"] = 3,
				["width"] = 126,
				["classColor"] = false,
				["CurveOffset"] = 0,
				["mouseOverTooltip"] = true,
				["leftOffset"] = 0,
				["maxTextWidth"] = 300,
				["scale"] = 91,
				["textX"] = 0,
				["LifeTime"] = 0,
			},
			["name"] = {
				["frameLayer"] = 1,
				["enable"] = true,
				["justifyV"] = 1,
				["width"] = 100,
				["y"] = 16,
				["x"] = -39,
				["justifyH"] = 2,
				["anchor"] = "Center",
				["frameStrata"] = 3,
				["scale"] = 100,
				["height"] = 12,
			},
			["model"] = {
				["frameStrata"] = 2,
				["zoom"] = 0,
				["frameLevel"] = 1,
				["frameLayer"] = 1,
				["scale"] = 89,
				["rotation"] = 0,
				["justifyV"] = "CENTER",
				["width"] = 191,
				["y"] = -187,
				["x"] = 20,
				["justifyH"] = "CENTER",
				["enable"] = false,
				["anchor"] = "BottomRight",
				["height"] = 191,
				["deathEffect"] = false,
				["clickThru"] = true,
			},
			["padH"] = 3,
			["buffs"] = {
				["color"] = {
					["a"] = 1,
					["b"] = 0,
					["g"] = 0,
					["r"] = 0,
				},
				["frameStrata"] = 2,
				["columns"] = 6,
				["frameLayer"] = 1,
				["scale"] = 64,
				["rows"] = 1,
				["alpha"] = 100,
				["isTopToBottom"] = false,
				["y"] = -11,
				["x"] = -94,
				["sort"] = "Duration",
				["spacing"] = 0,
				["anchor"] = "BottomRight",
				["enable"] = true,
				["showBG"] = false,
				["isLeftToRight"] = true,
			},
			["scale"] = 0.75,
			["cast"] = {
				["maxTextWidth"] = 98,
				["enable"] = true,
				["multi"] = true,
				["showBG"] = false,
				["sparkY"] = 0,
				["textheight"] = 12,
				["Sparkarc"] = 0,
				["backdropOpacity"] = 50,
				["frameLevel"] = 2,
				["anchor"] = "Right",
				["textY"] = 0,
				["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
				["x"] = -98,
				["orient"] = "HORIZONTAL",
				["frameStrata"] = 3,
				["textX"] = 0,
				["frameLayer"] = 8,
				["CurveOffset"] = 0,
				["yTextOffset"] = 0,
				["alpha"] = 100,
				["width"] = 117,
				["y"] = 17,
				["xTextOffset"] = 0,
				["mouseOverTooltip"] = true,
				["arc"] = 0,
				["height"] = 16,
				["anchorText"] = "Center",
				["scale"] = 100,
				["textureName"] = "Blizzard",
			},
		},
	}

 }
    
    local profiles = {}
    local info  = {}
    local function GetSettings()
        profiles = {}
            for profile, settings in pairs(CopyTable(DominosDB.profiles)) do
                for i, b in pairs(settings) do
                    for id, sets in pairs(settings.frames) do
                        if bar:IsViable(id) then
                            info[id] = Copy(sets)
                        end
                    end
                end
                profiles[profile] = Copy(info)
                info = {}                
            end
            for profile, settings in pairs(Copy(Base)) do
                profiles[profile] = settings
            end
        
        Dominos_Units = profiles
        
        return profiles
    end

    function OnTopMenuShow(panel)
        local info = UIDropDownMenu_CreateInfo()
        for profile, settings in pairs(GetSettings()) do
            wipe(info)
            info.text = profile
            info.value = profile
            info.keepShownOnClick = true
            info.displayMode = "MENU"
            info.hasArrow = 1
            UIDropDownMenu_AddButton(info)
        end
    end

    function OnSubMenuShow(panel, level, ...)
        local owner = panel.owner
        if not UIDROPDOWNMENU_MENU_VALUE then
            return
        end
      --  print(UIDROPDOWNMENU_MENU_VALUE, "~", ...)
        local info = UIDropDownMenu_CreateInfo()
        for id, layout in pairs(profiles[UIDROPDOWNMENU_MENU_VALUE]) do
            wipe(info)
            info.text = id
            info.func = function()
                local p = Copy(layout, bar.master.db.profile.frames[owner.id])
                bar.master.db.profile.frames[owner.id] = p
                owner.sets = p
                owner:Reload()
                owner:Layout()
                owner:Rescale()
                owner:Reposition()
                owner:Reanchor()
            end
            UIDropDownMenu_AddButton(info, 2, UIDROPDOWNMENU_MENU_VALUE)
        end
    end
end


local function GetProfiles()
	local copy = CopyTable(DominosDB.profiles)

	return copy
end

local function GetDominos()
	return bar.master.db.profile.frames
end

local frames =  {}

local function GetFrames(settings)
	wipe(frames)
	for id, info in pairs(settings.frames) do
		if bar:IsViable(id) then
			frames[id] = info
		end
	end
	return frames
end

local function FlipHorizontal(layout, looped)
	for key, value in pairs(layout) do
		if not looped then
			if (type(value) == 'table') then
				FlipHorizontal(value, true)
			end
		else
				if (key == 'anchor')then
					if string.find(value, 'Top') then
						layout[key] = string.gsub (value, 'Top', 'Bottom')
					elseif string.find(value, 'Bottom') then
						layout[key] = string.gsub (value, 'Bottom', 'Top')
					end
				end
				 if (key == 'justifyV') then
					if value == 1 then
						layout[key] = 3
					elseif  value == 3 then
						layout[key] = 1
					end
				 end
				if key == 'y' then
					layout[key] = -value					
				end
		end
	end
end

local function FlipVertical(layout, looped)
	for key, value in pairs(layout) do
		if (type(value) == 'table') then
			FlipVertical(value, true)
		else
			if looped then
				if (key == 'anchor')then
					if string.find(value, 'Left') then
						layout[key] = string.gsub (value, 'Left', 'Right')
					elseif string.find(value, 'Right') then
						layout[key] = string.gsub (value, 'Right', 'Left')
					end
				end
				 if (key == 'justifyH') then
					if value == 1 then
						layout[key] = 3
					elseif  value == 3 then
						layout[key] = 1
					end			 end
				if key == 'x' then
					layout[key] = -value					
				end
			end
		end
	end
end

local function AddLayoutPanel(menu)
	local panel = menu:NewPanel(L.Layout)
	panel.opacitySlider = panel:NewOpacitySlider()
	panel.fadeSlider = panel:NewFadeSlider()
	panel.paddingSlider = panel:NewPaddingSlider()



	panel:NewSlider({
		name = 'Height',
		min = 10,
		max = 600,
		get = function(self) --Getter
			return self:GetParent().owner.sets.height
		end,

		set = function(self) --Setter
			self:GetParent().owner.sets.height = self:GetValue()
			self:GetParent().owner:Layout()
		end,
	})
	panel:NewSlider({
		name = 'Width',
		min = 10,
		max = 600,
		get = function(self) --Getter
			return self:GetParent().owner.sets.width
		end,

		set = function(self) --Setter
			self:GetParent().owner.sets.width = self:GetValue()
			self:GetParent().owner:Layout()
		end,
	})


	panel.scaleSlider = panel:NewScaleSlider()
	return panel
end

local function AddShowState(self)
	local p = self:NewPanel(L.ShowStates)
	p.height = 56
	local editBox = CreateFrame('EditBox', NAME .. 'StateText', p, 'InputBoxTemplate')
	editBox:SetWidth(148) editBox:SetHeight(20)
	editBox:SetPoint('TOPLEFT', 12, -10)
	editBox:SetAutoFocus(false)
	editBox:SetScript('OnShow', function(self)
		self:SetText(self:GetParent().owner:GetShowStates() or '')
	end)
	editBox:SetScript('OnEnterPressed', function(self)
		local text = self:GetText()
		self:GetParent().owner:SetShowStates(text ~= '' and text or nil)
		self:ClearFocus()
	end)
	editBox:SetScript('OnEditFocusLost', function(self) self:HighlightText(0, 0) end)
	editBox:SetScript('OnEditFocusGained', function(self) self:HighlightText() end)
	local set = CreateFrame('Button', NAME .. 'Set', p, 'UIPanelButtonTemplate')
	NAME = NAME + 1
	set:SetWidth(30) set:SetHeight(20)
	set:SetText(L.Set)
	set:SetScript('OnClick', function(self)
		local text = editBox:GetText()
		self:GetParent().owner:SetShowStates(text ~= '' and text or nil)
		editBox:SetText(self:GetParent().owner:GetShowStates() or '')
		editBox:ClearFocus()
	end)
	set:SetPoint('BOTTOMRIGHT', -8, 2)
	return p
end

local function AddAdvancedPanel(menu)
	local panel = menu:NewPanel(L.Advanced)
	panel:NewClickThroughCheckbox()
	panel:NewShowInOverrideUICheckbox()
	panel:NewShowInPetBattleUICheckbox()
	
	local flipVert = bar.Menu.Button(panel, 'Flip Vertical')
	flipVert:SetScript('OnClick', function(self)
		FlipVertical(panel.owner.sets)
		panel.owner:Layout()
	end)

	local flipHori = bar.Menu.Button(panel, 'Flip Horizontal')
	flipHori:SetScript('OnClick', function(self)
		FlipHorizontal(panel.owner.sets)
		panel.owner:Layout()
	end)

	panel:NewSlider({
		name = 'Frame Layer',
		min = 1,
		max = 100,
		get = function(self) --Getter
									self:GetParent().owner.sets.frameLayer = self:GetParent().owner.sets.frameLayer or 4

			return self:GetParent().owner.sets.frameLayer
		end,

		set = function(self) --Setter
							self:GetParent().owner.sets.frameLayer = self:GetParent().owner.sets.frameLayer or 4

			self:GetParent().owner.sets.frameLayer = self:GetValue()
			self:GetParent().owner:Layout()
		end,
	})

	panel:NewSlider({
		name = 'Frame Strata',
		min = 1,
		max = 8,
		get = function(self) --Getter
					self:GetParent().owner.sets.frameStrata = self:GetParent().owner.sets.frameStrata or 4

			return self:GetParent().owner.sets.frameStrata
		end,

		set = function(self) --Setter
					self:GetParent().owner.sets.frameStrata = self:GetParent().owner.sets.frameStrata or 4

			self:GetParent().owner.sets.frameStrata = self:GetValue()
			self:GetParent().owner:Layout()
		end,
	})

	
	local f =  Menu(panel, 'Copy', 'profile')
	f:SetScript('OnShow', function(self)
		if self ~= f then
			return
		end
		f:initialize()
		if not self.stretch then
			self.stretch = 1
			f.button:SetHitRectInsets(0, -(f.title:GetCenter()+ (f.title:GetWidth()/2)- f.button:GetCenter()+ (f.button:GetWidth()/2)), 0, 0)
		end
	end)
	
	function f:initialize(level, ...)
        if level == 1 then
            OnTopMenuShow(panel)
        elseif (level == 2) and UIDROPDOWNMENU_MENU_VALUE then
            OnSubMenuShow(panel, level, ...)
        end
	end

	local b = bar.Menu.Button(panel, 'Delete Frame')
	b:SetScript('OnClick', function(self)
		if not b.clicked then
			b.clicked = true
			b:SetText('Are you sure?')
		else
			bar.master.db.profile.units.frames[panel.owner.id] = nil
			local frames = bar.frames
			if panel.owner then
				panel.owner:Delete()
				panel.owner.frameOverlay:Hide()
			end
			if LibStub and LibStub('LibKeyBound-1.0') then
				LibStub('LibKeyBound-1.0'):Deactivate()
			end
			bar.master:GetModule('ConfigOverlay'):Show()
			bar.menu:Hide()
		end
	end)

	return panel
end

function bar:CreateMenu()
	local menu = bar.master:NewMenu(self.id)
	local panel = AddLayoutPanel(menu)

	if self.components then
		for i, b in pairs(self.components) do
			if b.CreateMenu and bar.Menu then
				b:CreateMenu(menu)
			end
		end
	end

	--AddShowState(menu)
	AddAdvancedPanel(menu)
	return menu
end

local menu, config
function bar:ShowMenu()
	if not bar.master:IsConfigAddonEnabled() then return end
	config = config or LoadAddOn('Dominos_Config')
	L = L or LibStub('AceLocale-3.0'):GetLocale('Dominos-Config')
	bar.menu = bar.menu or self:CreateMenu()

	local menu = bar.menu
	menu:Hide()
	menu:SetOwner(self)
	menu:ShowPanel(L.Layout)
	menu:Show()
end
